/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * An analysis criterion.
     * <p></p>
     * Can be used to:
     * <ul>
     * <li>Analyze the performance of a {@link Strategy}
     * <li>Compare several {@link Strategy} together
     * </ul>
     * @class
     */
    export interface AnalysisCriterion {
        /**
         * @param {*} series a time series
         * @param {org.ta4j.core.Trade} trade a trade
         * @return {number} the criterion value for the trade
         */
        calculate(series? : any, trade? : any) : any;

        /**
         * @param {org.ta4j.core.TimeSeriesManager} manager the time series manager
         * @param {*[]} strategies a list of strategies
         * @return {*} the best strategy (among the provided ones) according to the criterion
         */
        chooseBest(manager : org.ta4j.core.TimeSeriesManager, strategies : Array<org.ta4j.core.Strategy>) : org.ta4j.core.Strategy;

        /**
         * @param {number} criterionValue1 the first value
         * @param {number} criterionValue2 the second value
         * @return {boolean} true if the first value is better than (according to the criterion) the second one, false otherwise
         */
        betterThan(criterionValue1 : number, criterionValue2 : number) : boolean;
    }
}

