/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * Constructor.
     * @param {java.time.Duration} timePeriod the time period
     * @param {java.time.ZonedDateTime} endTime the end time of the bar period
     * @param {org.ta4j.core.Decimal} openPrice the open price of the bar period
     * @param {org.ta4j.core.Decimal} highPrice the highest price of the bar period
     * @param {org.ta4j.core.Decimal} lowPrice the lowest price of the bar period
     * @param {org.ta4j.core.Decimal} closePrice the close price of the bar period
     * @param {org.ta4j.core.Decimal} volume the volume of the bar period
     * @param {org.ta4j.core.Decimal} amount the amount of the bar period
     * @class
     */
    export class BaseBar implements org.ta4j.core.Bar {
        isBullish() : boolean {
            let openPrice : org.ta4j.core.Decimal = this.getOpenPrice();
            let closePrice : org.ta4j.core.Decimal = this.getClosePrice();
            return (openPrice != null) && (closePrice != null) && openPrice.isLessThan(closePrice);
        }
        addTrade$java_lang_String$java_lang_String(tradeVolume : string, tradePrice : string) {
            this.addTrade(org.ta4j.core.Decimal.valueOf(tradeVolume), org.ta4j.core.Decimal.valueOf(tradePrice));
        }
        addTrade$double$double(tradeVolume : number, tradePrice : number) {
            this.addTrade(org.ta4j.core.Decimal.valueOf(tradeVolume), org.ta4j.core.Decimal.valueOf(tradePrice));
        }
        inPeriod(timestamp : java.time.ZonedDateTime) : boolean {
            return timestamp != null && !timestamp.isBefore(this.getBeginTime()) && timestamp.isBefore(this.getEndTime());
        }
        isBearish() : boolean {
            let openPrice : org.ta4j.core.Decimal = this.getOpenPrice();
            let closePrice : org.ta4j.core.Decimal = this.getClosePrice();
            return (openPrice != null) && (closePrice != null) && closePrice.isLessThan(openPrice);
        }
        getDateName() : string {
            return this.getEndTime().format(java.time.format.DateTimeFormatter.ISO_DATE_TIME);
        }
        getSimpleDateName() : string {
            return this.getEndTime().format(java.time.format.DateTimeFormatter.ISO_LOCAL_DATE_TIME);
        }
        static serialVersionUID : number = 8038383777467488147;

        /**
         * Time period (e.g. 1 day, 15 min, etc.) of the bar
         */
        /*private*/ timePeriod : java.time.Duration;

        /**
         * End time of the bar
         */
        /*private*/ endTime : java.time.ZonedDateTime;

        /**
         * Begin time of the bar
         */
        /*private*/ beginTime : java.time.ZonedDateTime;

        /**
         * Open price of the period
         */
        /*private*/ openPrice : org.ta4j.core.Decimal = null;

        /**
         * Close price of the period
         */
        /*private*/ closePrice : org.ta4j.core.Decimal = null;

        /**
         * Max price of the period
         */
        /*private*/ maxPrice : org.ta4j.core.Decimal = null;

        /**
         * Min price of the period
         */
        /*private*/ minPrice : org.ta4j.core.Decimal = null;

        /**
         * Traded amount during the period
         */
        /*private*/ amount : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();

        /**
         * Volume of the period
         */
        /*private*/ volume : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();

        /**
         * Trade count
         */
        /*private*/ trades : number = 0;

        public constructor(timePeriod? : any, endTime? : any, openPrice? : any, highPrice? : any, lowPrice? : any, closePrice? : any, volume? : any, amount? : any) {
            if(((timePeriod != null && timePeriod instanceof <any>java.time.Duration) || timePeriod === null) && ((endTime != null && endTime instanceof <any>java.time.ZonedDateTime) || endTime === null) && ((openPrice != null && openPrice instanceof <any>org.ta4j.core.Decimal) || openPrice === null) && ((highPrice != null && highPrice instanceof <any>org.ta4j.core.Decimal) || highPrice === null) && ((lowPrice != null && lowPrice instanceof <any>org.ta4j.core.Decimal) || lowPrice === null) && ((closePrice != null && closePrice instanceof <any>org.ta4j.core.Decimal) || closePrice === null) && ((volume != null && volume instanceof <any>org.ta4j.core.Decimal) || volume === null) && ((amount != null && amount instanceof <any>org.ta4j.core.Decimal) || amount === null)) {
                let __args = Array.prototype.slice.call(arguments);
                if(this.timePeriod===undefined) this.timePeriod = null;
                if(this.endTime===undefined) this.endTime = null;
                if(this.beginTime===undefined) this.beginTime = null;
                this.openPrice = null;
                this.closePrice = null;
                this.maxPrice = null;
                this.minPrice = null;
                this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                this.trades = 0;
                if(this.timePeriod===undefined) this.timePeriod = null;
                if(this.endTime===undefined) this.endTime = null;
                if(this.beginTime===undefined) this.beginTime = null;
                (() => {
                    this.checkTimeArguments(timePeriod, endTime);
                    this.timePeriod = timePeriod;
                    this.endTime = endTime;
                    this.beginTime = endTime.minus(timePeriod);
                    this.openPrice = openPrice;
                    this.maxPrice = highPrice;
                    this.minPrice = lowPrice;
                    this.closePrice = closePrice;
                    this.volume = volume;
                    this.amount = amount;
                })();
            } else if(((timePeriod != null && timePeriod instanceof <any>java.time.Duration) || timePeriod === null) && ((endTime != null && endTime instanceof <any>java.time.ZonedDateTime) || endTime === null) && ((openPrice != null && openPrice instanceof <any>org.ta4j.core.Decimal) || openPrice === null) && ((highPrice != null && highPrice instanceof <any>org.ta4j.core.Decimal) || highPrice === null) && ((lowPrice != null && lowPrice instanceof <any>org.ta4j.core.Decimal) || lowPrice === null) && ((closePrice != null && closePrice instanceof <any>org.ta4j.core.Decimal) || closePrice === null) && ((volume != null && volume instanceof <any>org.ta4j.core.Decimal) || volume === null) && amount === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let amount : any = org.ta4j.core.Decimal.ZERO_$LI$();
                    if(this.timePeriod===undefined) this.timePeriod = null;
                    if(this.endTime===undefined) this.endTime = null;
                    if(this.beginTime===undefined) this.beginTime = null;
                    this.openPrice = null;
                    this.closePrice = null;
                    this.maxPrice = null;
                    this.minPrice = null;
                    this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                    this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                    this.trades = 0;
                    if(this.timePeriod===undefined) this.timePeriod = null;
                    if(this.endTime===undefined) this.endTime = null;
                    if(this.beginTime===undefined) this.beginTime = null;
                    (() => {
                        this.checkTimeArguments(timePeriod, endTime);
                        this.timePeriod = timePeriod;
                        this.endTime = endTime;
                        this.beginTime = endTime.minus(timePeriod);
                        this.openPrice = openPrice;
                        this.maxPrice = highPrice;
                        this.minPrice = lowPrice;
                        this.closePrice = closePrice;
                        this.volume = volume;
                        this.amount = amount;
                    })();
                }
            } else if(((timePeriod != null && timePeriod instanceof <any>java.time.ZonedDateTime) || timePeriod === null) && ((typeof endTime === 'string') || endTime === null) && ((typeof openPrice === 'string') || openPrice === null) && ((typeof highPrice === 'string') || highPrice === null) && ((typeof lowPrice === 'string') || lowPrice === null) && ((typeof closePrice === 'string') || closePrice === null) && volume === undefined && amount === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let endTime : any = __args[0];
                let openPrice : any = __args[1];
                let highPrice : any = __args[2];
                let lowPrice : any = __args[3];
                let closePrice : any = __args[4];
                let volume : any = __args[5];
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let openPrice : any = org.ta4j.core.Decimal.valueOf$java_lang_String(__args[1]);
                    let highPrice : any = org.ta4j.core.Decimal.valueOf$java_lang_String(__args[2]);
                    let lowPrice : any = org.ta4j.core.Decimal.valueOf$java_lang_String(__args[3]);
                    let closePrice : any = org.ta4j.core.Decimal.valueOf$java_lang_String(__args[4]);
                    let volume : any = org.ta4j.core.Decimal.valueOf$java_lang_String(__args[5]);
                    {
                        let __args = Array.prototype.slice.call(arguments);
                        let timePeriod : any = java.time.Duration.ofDays(1);
                        {
                            let __args = Array.prototype.slice.call(arguments);
                            let amount : any = org.ta4j.core.Decimal.ZERO_$LI$();
                            if(this.timePeriod===undefined) this.timePeriod = null;
                            if(this.endTime===undefined) this.endTime = null;
                            if(this.beginTime===undefined) this.beginTime = null;
                            this.openPrice = null;
                            this.closePrice = null;
                            this.maxPrice = null;
                            this.minPrice = null;
                            this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                            this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                            this.trades = 0;
                            if(this.timePeriod===undefined) this.timePeriod = null;
                            if(this.endTime===undefined) this.endTime = null;
                            if(this.beginTime===undefined) this.beginTime = null;
                            (() => {
                                this.checkTimeArguments(timePeriod, endTime);
                                this.timePeriod = timePeriod;
                                this.endTime = endTime;
                                this.beginTime = endTime.minus(timePeriod);
                                this.openPrice = openPrice;
                                this.maxPrice = highPrice;
                                this.minPrice = lowPrice;
                                this.closePrice = closePrice;
                                this.volume = volume;
                                this.amount = amount;
                            })();
                        }
                    }
                }
            } else if(((timePeriod != null && timePeriod instanceof <any>java.time.ZonedDateTime) || timePeriod === null) && ((endTime != null && endTime instanceof <any>org.ta4j.core.Decimal) || endTime === null) && ((openPrice != null && openPrice instanceof <any>org.ta4j.core.Decimal) || openPrice === null) && ((highPrice != null && highPrice instanceof <any>org.ta4j.core.Decimal) || highPrice === null) && ((lowPrice != null && lowPrice instanceof <any>org.ta4j.core.Decimal) || lowPrice === null) && ((closePrice != null && closePrice instanceof <any>org.ta4j.core.Decimal) || closePrice === null) && volume === undefined && amount === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let endTime : any = __args[0];
                let openPrice : any = __args[1];
                let highPrice : any = __args[2];
                let lowPrice : any = __args[3];
                let closePrice : any = __args[4];
                let volume : any = __args[5];
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let timePeriod : any = java.time.Duration.ofDays(1);
                    {
                        let __args = Array.prototype.slice.call(arguments);
                        let amount : any = org.ta4j.core.Decimal.ZERO_$LI$();
                        if(this.timePeriod===undefined) this.timePeriod = null;
                        if(this.endTime===undefined) this.endTime = null;
                        if(this.beginTime===undefined) this.beginTime = null;
                        this.openPrice = null;
                        this.closePrice = null;
                        this.maxPrice = null;
                        this.minPrice = null;
                        this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                        this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                        this.trades = 0;
                        if(this.timePeriod===undefined) this.timePeriod = null;
                        if(this.endTime===undefined) this.endTime = null;
                        if(this.beginTime===undefined) this.beginTime = null;
                        (() => {
                            this.checkTimeArguments(timePeriod, endTime);
                            this.timePeriod = timePeriod;
                            this.endTime = endTime;
                            this.beginTime = endTime.minus(timePeriod);
                            this.openPrice = openPrice;
                            this.maxPrice = highPrice;
                            this.minPrice = lowPrice;
                            this.closePrice = closePrice;
                            this.volume = volume;
                            this.amount = amount;
                        })();
                    }
                }
            } else if(((timePeriod != null && timePeriod instanceof <any>java.time.ZonedDateTime) || timePeriod === null) && ((typeof endTime === 'number') || endTime === null) && ((typeof openPrice === 'number') || openPrice === null) && ((typeof highPrice === 'number') || highPrice === null) && ((typeof lowPrice === 'number') || lowPrice === null) && ((typeof closePrice === 'number') || closePrice === null) && volume === undefined && amount === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let endTime : any = __args[0];
                let openPrice : any = __args[1];
                let highPrice : any = __args[2];
                let lowPrice : any = __args[3];
                let closePrice : any = __args[4];
                let volume : any = __args[5];
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let openPrice : any = org.ta4j.core.Decimal.valueOf$double(__args[1]);
                    let highPrice : any = org.ta4j.core.Decimal.valueOf$double(__args[2]);
                    let lowPrice : any = org.ta4j.core.Decimal.valueOf$double(__args[3]);
                    let closePrice : any = org.ta4j.core.Decimal.valueOf$double(__args[4]);
                    let volume : any = org.ta4j.core.Decimal.valueOf$double(__args[5]);
                    {
                        let __args = Array.prototype.slice.call(arguments);
                        let timePeriod : any = java.time.Duration.ofDays(1);
                        {
                            let __args = Array.prototype.slice.call(arguments);
                            let amount : any = org.ta4j.core.Decimal.ZERO_$LI$();
                            if(this.timePeriod===undefined) this.timePeriod = null;
                            if(this.endTime===undefined) this.endTime = null;
                            if(this.beginTime===undefined) this.beginTime = null;
                            this.openPrice = null;
                            this.closePrice = null;
                            this.maxPrice = null;
                            this.minPrice = null;
                            this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                            this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                            this.trades = 0;
                            if(this.timePeriod===undefined) this.timePeriod = null;
                            if(this.endTime===undefined) this.endTime = null;
                            if(this.beginTime===undefined) this.beginTime = null;
                            (() => {
                                this.checkTimeArguments(timePeriod, endTime);
                                this.timePeriod = timePeriod;
                                this.endTime = endTime;
                                this.beginTime = endTime.minus(timePeriod);
                                this.openPrice = openPrice;
                                this.maxPrice = highPrice;
                                this.minPrice = lowPrice;
                                this.closePrice = closePrice;
                                this.volume = volume;
                                this.amount = amount;
                            })();
                        }
                    }
                }
            } else if(((timePeriod != null && timePeriod instanceof <any>java.time.Duration) || timePeriod === null) && ((endTime != null && endTime instanceof <any>java.time.ZonedDateTime) || endTime === null) && openPrice === undefined && highPrice === undefined && lowPrice === undefined && closePrice === undefined && volume === undefined && amount === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                if(this.timePeriod===undefined) this.timePeriod = null;
                if(this.endTime===undefined) this.endTime = null;
                if(this.beginTime===undefined) this.beginTime = null;
                this.openPrice = null;
                this.closePrice = null;
                this.maxPrice = null;
                this.minPrice = null;
                this.amount = org.ta4j.core.Decimal.ZERO_$LI$();
                this.volume = org.ta4j.core.Decimal.ZERO_$LI$();
                this.trades = 0;
                if(this.timePeriod===undefined) this.timePeriod = null;
                if(this.endTime===undefined) this.endTime = null;
                if(this.beginTime===undefined) this.beginTime = null;
                (() => {
                    this.checkTimeArguments(timePeriod, endTime);
                    this.timePeriod = timePeriod;
                    this.endTime = endTime;
                    this.beginTime = endTime.minus(timePeriod);
                })();
            } else throw new Error('invalid overload');
        }

        /**
         * @return {org.ta4j.core.Decimal} the open price of the period
         */
        public getOpenPrice() : org.ta4j.core.Decimal {
            return this.openPrice;
        }

        /**
         * @return {org.ta4j.core.Decimal} the min price of the period
         */
        public getMinPrice() : org.ta4j.core.Decimal {
            return this.minPrice;
        }

        /**
         * @return {org.ta4j.core.Decimal} the max price of the period
         */
        public getMaxPrice() : org.ta4j.core.Decimal {
            return this.maxPrice;
        }

        /**
         * @return {org.ta4j.core.Decimal} the close price of the period
         */
        public getClosePrice() : org.ta4j.core.Decimal {
            return this.closePrice;
        }

        /**
         * @return {org.ta4j.core.Decimal} the whole traded volume in the period
         */
        public getVolume() : org.ta4j.core.Decimal {
            return this.volume;
        }

        /**
         * @return {number} the number of trades in the period
         */
        public getTrades() : number {
            return this.trades;
        }

        /**
         * @return {org.ta4j.core.Decimal} the whole traded amount of the period
         */
        public getAmount() : org.ta4j.core.Decimal {
            return this.amount;
        }

        /**
         * @return {java.time.Duration} the time period of the bar
         */
        public getTimePeriod() : java.time.Duration {
            return this.timePeriod;
        }

        /**
         * @return {java.time.ZonedDateTime} the begin timestamp of the bar period
         */
        public getBeginTime() : java.time.ZonedDateTime {
            return this.beginTime;
        }

        /**
         * @return {java.time.ZonedDateTime} the end timestamp of the bar period
         */
        public getEndTime() : java.time.ZonedDateTime {
            return this.endTime;
        }

        public addTrade$org_ta4j_core_Decimal$org_ta4j_core_Decimal(tradeVolume : org.ta4j.core.Decimal, tradePrice : org.ta4j.core.Decimal) {
            if(this.openPrice == null) {
                this.openPrice = tradePrice;
            }
            this.closePrice = tradePrice;
            if(this.maxPrice == null) {
                this.maxPrice = tradePrice;
            } else {
                this.maxPrice = this.maxPrice.isLessThan(tradePrice)?tradePrice:this.maxPrice;
            }
            if(this.minPrice == null) {
                this.minPrice = tradePrice;
            } else {
                this.minPrice = this.minPrice.isGreaterThan(tradePrice)?tradePrice:this.minPrice;
            }
            this.volume = this.volume.plus(tradeVolume);
            this.amount = this.amount.plus(tradeVolume.multipliedBy(tradePrice));
            this.trades++;
        }

        /**
         * Adds a trade at the end of bar period.
         * @param {org.ta4j.core.Decimal} tradeVolume the traded volume
         * @param {org.ta4j.core.Decimal} tradePrice the price
         */
        public addTrade(tradeVolume? : any, tradePrice? : any) : any {
            if(((tradeVolume != null && tradeVolume instanceof <any>org.ta4j.core.Decimal) || tradeVolume === null) && ((tradePrice != null && tradePrice instanceof <any>org.ta4j.core.Decimal) || tradePrice === null)) {
                return <any>this.addTrade$org_ta4j_core_Decimal$org_ta4j_core_Decimal(tradeVolume, tradePrice);
            } else if(((typeof tradeVolume === 'string') || tradeVolume === null) && ((typeof tradePrice === 'string') || tradePrice === null)) {
                super.addTrade(tradeVolume, tradePrice);
            } else if(((typeof tradeVolume === 'number') || tradeVolume === null) && ((typeof tradePrice === 'number') || tradePrice === null)) {
                return <any>this.addTrade$double$double(tradeVolume, tradePrice);
            } else throw new Error('invalid overload');
        }

        /**
         * 
         * @return {string}
         */
        public toString() : string {
            return javaemul.internal.StringHelper.format("{end time: %1s, close price: %2$f, open price: %3$f, min price: %4$f, max price: %5$f, volume: %6$f}", this.endTime.withZoneSameInstant(java.time.ZoneId.systemDefault()), this.closePrice.doubleValue(), this.openPrice.doubleValue(), this.minPrice.doubleValue(), this.maxPrice.doubleValue(), this.volume.doubleValue());
        }

        /**
         * @param {java.time.Duration} timePeriod the time period
         * @param {java.time.ZonedDateTime} endTime the end time of the bar
         * @throws IllegalArgumentException if one of the arguments is null
         * @private
         */
        /*private*/ checkTimeArguments(timePeriod : java.time.Duration, endTime : java.time.ZonedDateTime) {
            if(timePeriod == null) {
                throw Object.defineProperty(new Error("Time period cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
            }
            if(endTime == null) {
                throw Object.defineProperty(new Error("End time cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
            }
        }
    }
    BaseBar["__class"] = "org.ta4j.core.BaseBar";
    BaseBar["__interfaces"] = ["org.ta4j.core.Bar","java.io.Serializable"];


}

