/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * Constructor.
     * @param {string} name the name of the strategy
     * @param {*} entryRule the entry rule
     * @param {*} exitRule the exit rule
     * @param {number} unstablePeriod strategy will ignore possible signals at <code>index</code> < <code>unstablePeriod</code>
     * @class
     */
    export class BaseStrategy implements org.ta4j.core.Strategy {
        shouldOperate(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean {
            let trade : org.ta4j.core.Trade = tradingRecord.getCurrentTrade();
            if(trade.isNew()) {
                return this.shouldEnter(index, tradingRecord);
            } else if(trade.isOpened()) {
                return this.shouldExit(index, tradingRecord);
            }
            return false;
        }
        shouldEnter$int(index : number) : boolean {
            return this.shouldEnter(index, null);
        }
        shouldExit$int(index : number) : boolean {
            return this.shouldExit(index, null);
        }
        /**
         * The logger
         */
        log : org.slf4j.Logger = org.slf4j.LoggerFactory.getLogger((<any>this.constructor));

        /**
         * The class name
         */
        className : string = /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor));

        /**
         * Name of the strategy
         */
        /*private*/ name : string;

        /**
         * The entry rule
         */
        /*private*/ entryRule : org.ta4j.core.Rule;

        /**
         * The exit rule
         */
        /*private*/ exitRule : org.ta4j.core.Rule;

        /**
         * The unstable period (number of bars).<br>
         * During the unstable period of the strategy any order placement will be cancelled.<br>
         * I.e. no entry/exit signal will be fired before index == unstablePeriod.
         */
        /*private*/ unstablePeriod : number;

        public constructor(name? : any, entryRule? : any, exitRule? : any, unstablePeriod? : any) {
            if(((typeof name === 'string') || name === null) && ((entryRule != null && (entryRule["__interfaces"] != null && entryRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || entryRule.constructor != null && entryRule.constructor["__interfaces"] != null && entryRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || entryRule === null) && ((exitRule != null && (exitRule["__interfaces"] != null && exitRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || exitRule.constructor != null && exitRule.constructor["__interfaces"] != null && exitRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || exitRule === null) && ((typeof unstablePeriod === 'number') || unstablePeriod === null)) {
                let __args = Array.prototype.slice.call(arguments);
                if(this.name===undefined) this.name = null;
                if(this.entryRule===undefined) this.entryRule = null;
                if(this.exitRule===undefined) this.exitRule = null;
                if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                this.log = org.slf4j.LoggerFactory.getLogger((<any>this.constructor));
                this.className = /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor));
                if(this.name===undefined) this.name = null;
                if(this.entryRule===undefined) this.entryRule = null;
                if(this.exitRule===undefined) this.exitRule = null;
                if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                (() => {
                    if(entryRule == null || exitRule == null) {
                        throw Object.defineProperty(new Error("Rules cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                    }
                    if(unstablePeriod < 0) {
                        throw Object.defineProperty(new Error("Unstable period bar count must be >= 0"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                    }
                    this.name = name;
                    this.entryRule = entryRule;
                    this.exitRule = exitRule;
                    this.unstablePeriod = unstablePeriod;
                })();
            } else if(((typeof name === 'string') || name === null) && ((entryRule != null && (entryRule["__interfaces"] != null && entryRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || entryRule.constructor != null && entryRule.constructor["__interfaces"] != null && entryRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || entryRule === null) && ((exitRule != null && (exitRule["__interfaces"] != null && exitRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || exitRule.constructor != null && exitRule.constructor["__interfaces"] != null && exitRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || exitRule === null) && unstablePeriod === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let unstablePeriod : any = 0;
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    this.log = org.slf4j.LoggerFactory.getLogger((<any>this.constructor));
                    this.className = /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor));
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    (() => {
                        if(entryRule == null || exitRule == null) {
                            throw Object.defineProperty(new Error("Rules cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        if(unstablePeriod < 0) {
                            throw Object.defineProperty(new Error("Unstable period bar count must be >= 0"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        this.name = name;
                        this.entryRule = entryRule;
                        this.exitRule = exitRule;
                        this.unstablePeriod = unstablePeriod;
                    })();
                }
            } else if(((name != null && (name["__interfaces"] != null && name["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || name.constructor != null && name.constructor["__interfaces"] != null && name.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || name === null) && ((entryRule != null && (entryRule["__interfaces"] != null && entryRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || entryRule.constructor != null && entryRule.constructor["__interfaces"] != null && entryRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || entryRule === null) && ((typeof exitRule === 'number') || exitRule === null) && unstablePeriod === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let entryRule : any = __args[0];
                let exitRule : any = __args[1];
                let unstablePeriod : any = __args[2];
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let name : any = null;
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    this.log = org.slf4j.LoggerFactory.getLogger((<any>this.constructor));
                    this.className = /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor));
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    (() => {
                        if(entryRule == null || exitRule == null) {
                            throw Object.defineProperty(new Error("Rules cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        if(unstablePeriod < 0) {
                            throw Object.defineProperty(new Error("Unstable period bar count must be >= 0"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        this.name = name;
                        this.entryRule = entryRule;
                        this.exitRule = exitRule;
                        this.unstablePeriod = unstablePeriod;
                    })();
                }
            } else if(((name != null && (name["__interfaces"] != null && name["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || name.constructor != null && name.constructor["__interfaces"] != null && name.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || name === null) && ((entryRule != null && (entryRule["__interfaces"] != null && entryRule["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0 || entryRule.constructor != null && entryRule.constructor["__interfaces"] != null && entryRule.constructor["__interfaces"].indexOf("org.ta4j.core.Rule") >= 0)) || entryRule === null) && exitRule === undefined && unstablePeriod === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let entryRule : any = __args[0];
                let exitRule : any = __args[1];
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let name : any = null;
                    let unstablePeriod : any = 0;
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    this.log = org.slf4j.LoggerFactory.getLogger((<any>this.constructor));
                    this.className = /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor));
                    if(this.name===undefined) this.name = null;
                    if(this.entryRule===undefined) this.entryRule = null;
                    if(this.exitRule===undefined) this.exitRule = null;
                    if(this.unstablePeriod===undefined) this.unstablePeriod = 0;
                    (() => {
                        if(entryRule == null || exitRule == null) {
                            throw Object.defineProperty(new Error("Rules cannot be null"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        if(unstablePeriod < 0) {
                            throw Object.defineProperty(new Error("Unstable period bar count must be >= 0"), '__classes', { configurable: true, value: ['java.lang.Throwable','java.lang.Object','java.lang.RuntimeException','java.lang.IllegalArgumentException','java.lang.Exception'] });
                        }
                        this.name = name;
                        this.entryRule = entryRule;
                        this.exitRule = exitRule;
                        this.unstablePeriod = unstablePeriod;
                    })();
                }
            } else throw new Error('invalid overload');
        }

        /**
         * 
         * @return {string}
         */
        public getName() : string {
            return this.name;
        }

        /**
         * 
         * @return {*}
         */
        public getEntryRule() : org.ta4j.core.Rule {
            return this.entryRule;
        }

        /**
         * 
         * @return {*}
         */
        public getExitRule() : org.ta4j.core.Rule {
            return this.exitRule;
        }

        /**
         * 
         * @return {number}
         */
        public getUnstablePeriod() : number {
            return this.unstablePeriod;
        }

        /**
         * 
         * @param {number} unstablePeriod
         */
        public setUnstablePeriod(unstablePeriod : number) {
            this.unstablePeriod = unstablePeriod;
        }

        /**
         * 
         * @param {number} index
         * @return {boolean}
         */
        public isUnstableAt(index : number) : boolean {
            return index < this.unstablePeriod;
        }

        public shouldEnter$int$org_ta4j_core_TradingRecord(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean {
            let enter : boolean = org.ta4j.core.Strategy.super['shouldEnter$int$org_ta4j_core_TradingRecord'](index, tradingRecord);
            this.traceShouldEnter(index, enter);
            return enter;
        }

        /**
         * 
         * @param {number} index
         * @param {*} tradingRecord
         * @return {boolean}
         */
        public shouldEnter(index? : any, tradingRecord? : any) : any {
            if(((typeof index === 'number') || index === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.shouldEnter$int$org_ta4j_core_TradingRecord(index, tradingRecord);
            } else if(((typeof index === 'number') || index === null) && tradingRecord === undefined) {
                return <any>this.shouldEnter$int(index);
            } else throw new Error('invalid overload');
        }

        public shouldExit$int$org_ta4j_core_TradingRecord(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean {
            let exit : boolean = org.ta4j.core.Strategy.super['shouldExit$int$org_ta4j_core_TradingRecord'](index, tradingRecord);
            this.traceShouldExit(index, exit);
            return exit;
        }

        /**
         * 
         * @param {number} index
         * @param {*} tradingRecord
         * @return {boolean}
         */
        public shouldExit(index? : any, tradingRecord? : any) : any {
            if(((typeof index === 'number') || index === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.shouldExit$int$org_ta4j_core_TradingRecord(index, tradingRecord);
            } else if(((typeof index === 'number') || index === null) && tradingRecord === undefined) {
                return <any>this.shouldExit$int(index);
            } else throw new Error('invalid overload');
        }

        public and$org_ta4j_core_Strategy(strategy : org.ta4j.core.Strategy) : org.ta4j.core.Strategy {
            let andName : string = "and(" + this.name + "," + strategy.getName() + ")";
            let unstable : number = this.unstablePeriod > strategy.getUnstablePeriod()?this.unstablePeriod:strategy.getUnstablePeriod();
            return this.and$java_lang_String$org_ta4j_core_Strategy$int(andName, strategy, unstable);
        }

        public or$org_ta4j_core_Strategy(strategy : org.ta4j.core.Strategy) : org.ta4j.core.Strategy {
            let orName : string = "or(" + this.name + "," + strategy.getName() + ")";
            let unstable : number = this.unstablePeriod > strategy.getUnstablePeriod()?this.unstablePeriod:strategy.getUnstablePeriod();
            return this.or$java_lang_String$org_ta4j_core_Strategy$int(orName, strategy, unstable);
        }

        /**
         * 
         * @return {*}
         */
        public opposite() : org.ta4j.core.Strategy {
            return new BaseStrategy("opposite(" + this.name + ")", this.exitRule, this.entryRule, this.unstablePeriod);
        }

        public and$java_lang_String$org_ta4j_core_Strategy$int(name : string, strategy : org.ta4j.core.Strategy, unstablePeriod : number) : org.ta4j.core.Strategy {
            return new BaseStrategy(name, this.entryRule.and(strategy.getEntryRule()), this.exitRule.and(strategy.getExitRule()), unstablePeriod);
        }

        /**
         * 
         * @param {string} name
         * @param {*} strategy
         * @param {number} unstablePeriod
         * @return {*}
         */
        public and(name? : any, strategy? : any, unstablePeriod? : any) : any {
            if(((typeof name === 'string') || name === null) && ((strategy != null && (strategy["__interfaces"] != null && strategy["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0 || strategy.constructor != null && strategy.constructor["__interfaces"] != null && strategy.constructor["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0)) || strategy === null) && ((typeof unstablePeriod === 'number') || unstablePeriod === null)) {
                return <any>this.and$java_lang_String$org_ta4j_core_Strategy$int(name, strategy, unstablePeriod);
            } else if(((name != null && (name["__interfaces"] != null && name["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0 || name.constructor != null && name.constructor["__interfaces"] != null && name.constructor["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0)) || name === null) && strategy === undefined && unstablePeriod === undefined) {
                return <any>this.and$org_ta4j_core_Strategy(name);
            } else throw new Error('invalid overload');
        }

        public or$java_lang_String$org_ta4j_core_Strategy$int(name : string, strategy : org.ta4j.core.Strategy, unstablePeriod : number) : org.ta4j.core.Strategy {
            return new BaseStrategy(name, this.entryRule.or(strategy.getEntryRule()), this.exitRule.or(strategy.getExitRule()), unstablePeriod);
        }

        /**
         * 
         * @param {string} name
         * @param {*} strategy
         * @param {number} unstablePeriod
         * @return {*}
         */
        public or(name? : any, strategy? : any, unstablePeriod? : any) : any {
            if(((typeof name === 'string') || name === null) && ((strategy != null && (strategy["__interfaces"] != null && strategy["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0 || strategy.constructor != null && strategy.constructor["__interfaces"] != null && strategy.constructor["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0)) || strategy === null) && ((typeof unstablePeriod === 'number') || unstablePeriod === null)) {
                return <any>this.or$java_lang_String$org_ta4j_core_Strategy$int(name, strategy, unstablePeriod);
            } else if(((name != null && (name["__interfaces"] != null && name["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0 || name.constructor != null && name.constructor["__interfaces"] != null && name.constructor["__interfaces"].indexOf("org.ta4j.core.Strategy") >= 0)) || name === null) && strategy === undefined && unstablePeriod === undefined) {
                return <any>this.or$org_ta4j_core_Strategy(name);
            } else throw new Error('invalid overload');
        }

        /**
         * Traces the shouldEnter() method calls.
         * @param {number} index the bar index
         * @param {boolean} enter true if the strategy should enter, false otherwise
         */
        traceShouldEnter(index : number, enter : boolean) {
            this.log.trace$java_lang_String$java_lang_Object(">>> {}#shouldEnter({}): {}", this.className, index, enter);
        }

        /**
         * Traces the shouldExit() method calls.
         * @param {number} index the bar index
         * @param {boolean} exit true if the strategy should exit, false otherwise
         */
        traceShouldExit(index : number, exit : boolean) {
            this.log.trace$java_lang_String$java_lang_Object(">>> {}#shouldExit({}): {}", this.className, index, exit);
        }
    }
    BaseStrategy["__class"] = "org.ta4j.core.BaseStrategy";
    BaseStrategy["__interfaces"] = ["org.ta4j.core.Strategy"];


}

