/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * Indicator over a {@link TimeSeries}.
     * <p/p>
     * For each index of the time series, returns a value of type <b>T</b>.
     * 
     * @param <T> the type of returned value (Double, Boolean, etc.)
     * @class
     */
    export interface Indicator<T> {
        /**
         * @param {number} index the bar index
         * @return {*} the value of the indicator
         */
        getValue(index : number) : T;

        /**
         * @return {*} the related time series
         */
        getTimeSeries() : org.ta4j.core.TimeSeries;
    }

    export namespace Indicator {

        /**
         * Returns all values from an {@link Indicator} as a Array of Doubles. The
         * returned doubles could have a minor loss of precise, if {@link Indicator}
         * was based on {@link Decimal}.
         * 
         * @param {*} ref the indicator
         * @param {number} index the index
         * @param {number} timeFrame the timeFrame
         * @return {Array} array of double within the timeFrame
         */
        export function toDouble(ref : Indicator<org.ta4j.core.Decimal>, index : number, timeFrame : number) : number[] {
            let all : number[] = (s => { let a=[]; while(s-->0) a.push(null); return a; })(timeFrame);
            for(let i : number = Math.max(0, index - timeFrame + 1); i <= index; i++) {
                let number : org.ta4j.core.Decimal = ref.getValue(index);
                all[i] = number.doubleValue();
            };
            return all;
        }
    }

}

