/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * A rule for strategy building.
     * <p></p>
     * A trading rule may be composed of a combination of other rules.
     * 
     * A {@link Strategy} is a pair of complementary (entry and exit) rules.
     * @class
     */
    export interface Rule {
        /**
         * @param {*} rule another trading rule
         * @return {*} a rule which is the AND combination of this rule with the provided one
         */
        and(rule : Rule) : Rule;

        /**
         * @param {*} rule another trading rule
         * @return {*} a rule which is the OR combination of this rule with the provided one
         */
        or(rule : Rule) : Rule;

        /**
         * @param {*} rule another trading rule
         * @return {*} a rule which is the XOR combination of this rule with the provided one
         */
        xor(rule : Rule) : Rule;

        /**
         * @return {*} a rule which is the logical negation of this rule
         */
        negation() : Rule;

        /**
         * @param {number} index the bar index
         * @param {*} tradingRecord the potentially needed trading history
         * @return {boolean} true if this rule is satisfied for the provided index, false otherwise
         */
        isSatisfied(index? : any, tradingRecord? : any) : any;
    }
}

