/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core {
    /**
     * A trading strategy.
     * <p></p>
     * A strategy is a pair of complementary {@link Rule}. It may recommend to enter or to exit.
     * Recommendations are based respectively on the entry rule or on the exit rule.
     * @class
     */
    export interface Strategy {
        /**
         * @return {string} the name of the strategy
         */
        getName() : string;

        /**
         * @return {*} the entry rule
         */
        getEntryRule() : org.ta4j.core.Rule;

        /**
         * @return {*} the exit rule
         */
        getExitRule() : org.ta4j.core.Rule;

        /**
         * @param {string} name the name of the strategy
         * @param {*} strategy the other strategy
         * @param {number} unstablePeriod number of bars that will be strip off for this strategy
         * @return {*} the AND combination of two {@link Strategy}
         */
        and(name? : any, strategy? : any, unstablePeriod? : any) : any;

        /**
         * @param {string} name the name of the strategy
         * @param {*} strategy the other strategy
         * @param {number} unstablePeriod number of bars that will be strip off for this strategy
         * @return {*} the OR combination of two {@link Strategy}
         */
        or(name? : any, strategy? : any, unstablePeriod? : any) : any;

        /**
         * @return {*} the opposite of the {@link Strategy}
         */
        opposite() : Strategy;

        /**
         * @param {number} unstablePeriod number of bars that will be strip off for this strategy
         */
        setUnstablePeriod(unstablePeriod : number);

        /**
         * @return {number} unstablePeriod number of bars that will be strip off for this strategy
         */
        getUnstablePeriod() : number;

        /**
         * @param {number} index a bar index
         * @return {boolean} true if this strategy is unstable at the provided index, false otherwise (stable)
         */
        isUnstableAt(index : number) : boolean;

        /**
         * @param {number} index the bar index
         * @param {*} tradingRecord the potentially needed trading history
         * @return {boolean} true to recommend an order, false otherwise (no recommendation)
         */
        shouldOperate(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean;

        /**
         * @param {number} index the bar index
         * @param {*} tradingRecord the potentially needed trading history
         * @return {boolean} true to recommend to enter, false otherwise
         */
        shouldEnter(index? : any, tradingRecord? : any) : any;

        /**
         * @param {number} index the bar index
         * @param {*} tradingRecord the potentially needed trading history
         * @return {boolean} true to recommend to exit, false otherwise
         */
        shouldExit(index? : any, tradingRecord? : any) : any;
    }
}

