/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis {
    /**
     * Constructor.
     * @param {*} timeSeries the time series
     * @param {org.ta4j.core.Trade} trade a single trade
     * @class
     */
    export class CashFlow implements org.ta4j.core.Indicator<org.ta4j.core.Decimal> {
        /**
         * The time series
         */
        /*private*/ timeSeries : org.ta4j.core.TimeSeries;

        /**
         * The cash flow values
         */
        /*private*/ values : Array<org.ta4j.core.Decimal> = <any>(/* singletonList */[org.ta4j.core.Decimal.ONE_$LI$()].slice(0));

        public constructor(timeSeries? : any, trade? : any) {
            if(((timeSeries != null && (timeSeries["__interfaces"] != null && timeSeries["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || timeSeries.constructor != null && timeSeries.constructor["__interfaces"] != null && timeSeries.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || timeSeries === null) && ((trade != null && trade instanceof <any>org.ta4j.core.Trade) || trade === null)) {
                let __args = Array.prototype.slice.call(arguments);
                if(this.timeSeries===undefined) this.timeSeries = null;
                this.values = <any>(/* singletonList */[org.ta4j.core.Decimal.ONE_$LI$()].slice(0));
                if(this.timeSeries===undefined) this.timeSeries = null;
                (() => {
                    this.timeSeries = timeSeries;
                    this.calculate$org_ta4j_core_Trade(trade);
                    this.fillToTheEnd();
                })();
            } else if(((timeSeries != null && (timeSeries["__interfaces"] != null && timeSeries["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || timeSeries.constructor != null && timeSeries.constructor["__interfaces"] != null && timeSeries.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || timeSeries === null) && ((trade != null && (trade["__interfaces"] != null && trade["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || trade.constructor != null && trade.constructor["__interfaces"] != null && trade.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || trade === null)) {
                let __args = Array.prototype.slice.call(arguments);
                let tradingRecord : any = __args[1];
                if(this.timeSeries===undefined) this.timeSeries = null;
                this.values = <any>(/* singletonList */[org.ta4j.core.Decimal.ONE_$LI$()].slice(0));
                if(this.timeSeries===undefined) this.timeSeries = null;
                (() => {
                    this.timeSeries = timeSeries;
                    this.calculate$org_ta4j_core_TradingRecord(tradingRecord);
                    this.fillToTheEnd();
                })();
            } else throw new Error('invalid overload');
        }

        /**
         * @param {number} index the bar index
         * @return {org.ta4j.core.Decimal} the cash flow value at the index-th position
         */
        public getValue(index : number) : org.ta4j.core.Decimal {
            return /* get */this.values[index];
        }

        /**
         * 
         * @return {*}
         */
        public getTimeSeries() : org.ta4j.core.TimeSeries {
            return this.timeSeries;
        }

        /**
         * @return {number} the size of the time series
         */
        public getSize() : number {
            return this.timeSeries.getBarCount();
        }

        public calculate$org_ta4j_core_Trade(trade : org.ta4j.core.Trade) {
            let entryIndex : number = trade.getEntry().getIndex();
            let begin : number = entryIndex + 1;
            if(begin > /* size */(<number>this.values.length)) {
                let lastValue : org.ta4j.core.Decimal = /* get */this.values[/* size */(<number>this.values.length) - 1];
                /* addAll */((l1, l2) => l1.push.apply(l1, l2))(this.values, java.util.Collections.nCopies<any>(begin - /* size */(<number>this.values.length), lastValue));
            }
            let end : number = trade.getExit().getIndex();
            for(let i : number = Math.max(begin, 1); i <= end; i++) {
                let ratio : org.ta4j.core.Decimal;
                if(trade.getEntry().isBuy()) {
                    ratio = this.timeSeries.getBar(i).getClosePrice().dividedBy(this.timeSeries.getBar(entryIndex).getClosePrice());
                } else {
                    ratio = this.timeSeries.getBar(entryIndex).getClosePrice().dividedBy(this.timeSeries.getBar(i).getClosePrice());
                }
                /* add */(this.values.push(/* get */this.values[entryIndex].multipliedBy(ratio))>0);
            };
        }

        /**
         * Calculates the cash flow for a single trade.
         * @param {org.ta4j.core.Trade} trade a single trade
         * @private
         */
        public calculate(trade? : any) : any {
            if(((trade != null && trade instanceof <any>org.ta4j.core.Trade) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_Trade(trade);
            } else if(((trade != null && (trade["__interfaces"] != null && trade["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || trade.constructor != null && trade.constructor["__interfaces"] != null && trade.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_TradingRecord(trade);
            } else throw new Error('invalid overload');
        }

        /*private*/ calculate$org_ta4j_core_TradingRecord(tradingRecord : org.ta4j.core.TradingRecord) {
            {
                let array122 = tradingRecord.getTrades();
                for(let index121=0; index121 < array122.length; index121++) {
                    let trade = array122[index121];
                    {
                        this.calculate$org_ta4j_core_Trade(trade);
                    }
                }
            }
        }

        /**
         * Fills with last value till the end of the series.
         * @private
         */
        /*private*/ fillToTheEnd() {
            if(this.timeSeries.getEndIndex() >= /* size */(<number>this.values.length)) {
                let lastValue : org.ta4j.core.Decimal = /* get */this.values[/* size */(<number>this.values.length) - 1];
                /* addAll */((l1, l2) => l1.push.apply(l1, l2))(this.values, java.util.Collections.nCopies<any>(this.timeSeries.getEndIndex() - /* size */(<number>this.values.length) + 1, lastValue));
            }
        }
    }
    CashFlow["__class"] = "org.ta4j.core.analysis.CashFlow";
    CashFlow["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

