/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis.criteria {
    /**
     * Average profitable trades criterion.
     * <p></p>
     * The number of profitable trades.
     * @class
     * @extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion
     */
    export class AverageProfitableTradesCriterion extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion {
        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            let entryIndex : number = trade.getEntry().getIndex();
            let exitIndex : number = trade.getExit().getIndex();
            let result : org.ta4j.core.Decimal;
            if(trade.getEntry().isBuy()) {
                result = series.getBar(exitIndex).getClosePrice().dividedBy(series.getBar(entryIndex).getClosePrice());
            } else {
                result = series.getBar(entryIndex).getClosePrice().dividedBy(series.getBar(exitIndex).getClosePrice());
            }
            return (result.isGreaterThan(org.ta4j.core.Decimal.ONE_$LI$()))?1.0:0.0;
        }

        /**
         * 
         * @param {*} series
         * @param {org.ta4j.core.Trade} trade
         * @return {number}
         */
        public calculate(series? : any, trade? : any) : any {
            if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((trade != null && trade instanceof <any>org.ta4j.core.Trade) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, trade);
            } else if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((trade != null && (trade["__interfaces"] != null && trade["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || trade.constructor != null && trade.constructor["__interfaces"] != null && trade.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series, trade);
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series : org.ta4j.core.TimeSeries, tradingRecord : org.ta4j.core.TradingRecord) : number {
            let numberOfProfitable : number = 0;
            {
                let array126 = tradingRecord.getTrades();
                for(let index125=0; index125 < array126.length; index125++) {
                    let trade = array126[index125];
                    {
                        let entryIndex : number = trade.getEntry().getIndex();
                        let exitIndex : number = trade.getExit().getIndex();
                        let result : org.ta4j.core.Decimal;
                        if(trade.getEntry().isBuy()) {
                            result = series.getBar(exitIndex).getClosePrice().dividedBy(series.getBar(entryIndex).getClosePrice());
                        } else {
                            result = series.getBar(entryIndex).getClosePrice().dividedBy(series.getBar(exitIndex).getClosePrice());
                        }
                        if(result.isGreaterThan(org.ta4j.core.Decimal.ONE_$LI$())) {
                            numberOfProfitable++;
                        }
                    }
                }
            }
            return (<number>numberOfProfitable) / tradingRecord.getTradeCount();
        }

        /**
         * 
         * @param {number} criterionValue1
         * @param {number} criterionValue2
         * @return {boolean}
         */
        public betterThan(criterionValue1 : number, criterionValue2 : number) : boolean {
            return criterionValue1 > criterionValue2;
        }

        constructor() {
            super();
        }
    }
    AverageProfitableTradesCriterion["__class"] = "org.ta4j.core.analysis.criteria.AverageProfitableTradesCriterion";
    AverageProfitableTradesCriterion["__interfaces"] = ["org.ta4j.core.AnalysisCriterion"];


}

