/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis.criteria {
    /**
     * Buy and hold criterion.
     * <p></p>
     * @see <a href="http://en.wikipedia.org/wiki/Buy_and_hold">http://en.wikipedia.org/wiki/Buy_and_hold</a>
     * @class
     * @extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion
     */
    export class BuyAndHoldCriterion extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion {
        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series : org.ta4j.core.TimeSeries, tradingRecord : org.ta4j.core.TradingRecord) : number {
            return series.getBar(series.getEndIndex()).getClosePrice().dividedBy(series.getBar(series.getBeginIndex()).getClosePrice()).doubleValue();
        }

        /**
         * 
         * @param {*} series
         * @param {*} tradingRecord
         * @return {number}
         */
        public calculate(series? : any, tradingRecord? : any) : any {
            if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series, tradingRecord);
            } else if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && tradingRecord instanceof <any>org.ta4j.core.Trade) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, tradingRecord);
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            let entryIndex : number = trade.getEntry().getIndex();
            let exitIndex : number = trade.getExit().getIndex();
            if(trade.getEntry().isBuy()) {
                return series.getBar(exitIndex).getClosePrice().dividedBy(series.getBar(entryIndex).getClosePrice()).doubleValue();
            } else {
                return series.getBar(entryIndex).getClosePrice().dividedBy(series.getBar(exitIndex).getClosePrice()).doubleValue();
            }
        }

        /**
         * 
         * @param {number} criterionValue1
         * @param {number} criterionValue2
         * @return {boolean}
         */
        public betterThan(criterionValue1 : number, criterionValue2 : number) : boolean {
            return criterionValue1 > criterionValue2;
        }

        constructor() {
            super();
        }
    }
    BuyAndHoldCriterion["__class"] = "org.ta4j.core.analysis.criteria.BuyAndHoldCriterion";
    BuyAndHoldCriterion["__interfaces"] = ["org.ta4j.core.AnalysisCriterion"];


}

