/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis.criteria {
    /**
     * Constructor.
     * (a * x + b)
     * @param {number} initialAmount the initially traded amount
     * @param {number} a the a coefficient (e.g. 0.005 for 0.5% per {@link Order})
     * @param {number} b the b constant (e.g. 0.2 for $0.2 per {@link Order})
     * @class
     * @extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion
     */
    export class LinearTransactionCostCriterion extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion {
        /*private*/ initialAmount : number;

        /*private*/ a : number;

        /*private*/ b : number;

        /*private*/ profit : org.ta4j.core.analysis.criteria.TotalProfitCriterion;

        public constructor(initialAmount? : any, a? : any, b? : any) {
            if(((typeof initialAmount === 'number') || initialAmount === null) && ((typeof a === 'number') || a === null) && ((typeof b === 'number') || b === null)) {
                let __args = Array.prototype.slice.call(arguments);
                super();
                if(this.initialAmount===undefined) this.initialAmount = 0;
                if(this.a===undefined) this.a = 0;
                if(this.b===undefined) this.b = 0;
                if(this.profit===undefined) this.profit = null;
                if(this.initialAmount===undefined) this.initialAmount = 0;
                if(this.a===undefined) this.a = 0;
                if(this.b===undefined) this.b = 0;
                if(this.profit===undefined) this.profit = null;
                (() => {
                    this.initialAmount = initialAmount;
                    this.a = a;
                    this.b = b;
                    this.profit = new org.ta4j.core.analysis.criteria.TotalProfitCriterion();
                })();
            } else if(((typeof initialAmount === 'number') || initialAmount === null) && ((typeof a === 'number') || a === null) && b === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let b : any = 0;
                    super();
                    if(this.initialAmount===undefined) this.initialAmount = 0;
                    if(this.a===undefined) this.a = 0;
                    if(this.b===undefined) this.b = 0;
                    if(this.profit===undefined) this.profit = null;
                    if(this.initialAmount===undefined) this.initialAmount = 0;
                    if(this.a===undefined) this.a = 0;
                    if(this.b===undefined) this.b = 0;
                    if(this.profit===undefined) this.profit = null;
                    (() => {
                        this.initialAmount = initialAmount;
                        this.a = a;
                        this.b = b;
                        this.profit = new org.ta4j.core.analysis.criteria.TotalProfitCriterion();
                    })();
                }
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            return this.getTradeCost(series, trade, this.initialAmount);
        }

        /**
         * 
         * @param {*} series
         * @param {org.ta4j.core.Trade} trade
         * @return {number}
         */
        public calculate(series? : any, trade? : any) : any {
            if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((trade != null && trade instanceof <any>org.ta4j.core.Trade) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, trade);
            } else if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((trade != null && (trade["__interfaces"] != null && trade["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || trade.constructor != null && trade.constructor["__interfaces"] != null && trade.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || trade === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series, trade);
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series : org.ta4j.core.TimeSeries, tradingRecord : org.ta4j.core.TradingRecord) : number {
            let totalCosts : number = 0.0;
            let tradedAmount : number = this.initialAmount;
            {
                let array124 = tradingRecord.getTrades();
                for(let index123=0; index123 < array124.length; index123++) {
                    let trade = array124[index123];
                    {
                        let tradeCost : number = this.getTradeCost(series, trade, tradedAmount);
                        totalCosts += tradeCost;
                        tradedAmount = (tradedAmount - this.getOrderCost(trade.getEntry(), tradedAmount));
                        tradedAmount *= this.profit.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, trade);
                        tradedAmount -= this.getOrderCost(trade.getExit(), tradedAmount);
                    }
                }
            }
            let currentTrade : org.ta4j.core.Trade = tradingRecord.getCurrentTrade();
            if(currentTrade.isOpened()) {
                totalCosts += this.getOrderCost(currentTrade.getEntry(), tradedAmount);
            }
            return totalCosts;
        }

        /**
         * 
         * @param {number} criterionValue1
         * @param {number} criterionValue2
         * @return {boolean}
         */
        public betterThan(criterionValue1 : number, criterionValue2 : number) : boolean {
            return criterionValue1 < criterionValue2;
        }

        /**
         * @param {org.ta4j.core.Order} order a trade order
         * @param {number} tradedAmount the traded amount for the order
         * @return {number} the absolute order cost
         * @private
         */
        /*private*/ getOrderCost(order : org.ta4j.core.Order, tradedAmount : number) : number {
            let orderCost : number = 0.0;
            if(order != null) {
                return this.a * tradedAmount + this.b;
            }
            return orderCost;
        }

        /**
         * @param {*} series the time series
         * @param {org.ta4j.core.Trade} trade a trade
         * @param {number} initialAmount the initially traded amount for the trade
         * @return {number} the absolute total cost of all orders in the trade
         * @private
         */
        /*private*/ getTradeCost(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade, initialAmount : number) : number {
            let totalTradeCost : number = 0.0;
            if(trade != null) {
                if(trade.getEntry() != null) {
                    totalTradeCost = this.getOrderCost(trade.getEntry(), initialAmount);
                    if(trade.getExit() != null) {
                        let newTradedAmount : number = (initialAmount - totalTradeCost) * this.profit.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, trade);
                        totalTradeCost += this.getOrderCost(trade.getExit(), newTradedAmount);
                    }
                }
            }
            return totalTradeCost;
        }
    }
    LinearTransactionCostCriterion["__class"] = "org.ta4j.core.analysis.criteria.LinearTransactionCostCriterion";
    LinearTransactionCostCriterion["__interfaces"] = ["org.ta4j.core.AnalysisCriterion"];


}

