/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis.criteria {
    /**
     * Maximum drawdown criterion.
     * <p></p>
     * @see <a href="http://en.wikipedia.org/wiki/Drawdown_%28economics%29">http://en.wikipedia.org/wiki/Drawdown_%28economics%29</a>
     * @class
     * @extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion
     */
    export class MaximumDrawdownCriterion extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion {
        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series : org.ta4j.core.TimeSeries, tradingRecord : org.ta4j.core.TradingRecord) : number {
            let cashFlow : org.ta4j.core.analysis.CashFlow = new org.ta4j.core.analysis.CashFlow(series, tradingRecord);
            let maximumDrawdown : org.ta4j.core.Decimal = this.calculateMaximumDrawdown(series, cashFlow);
            return maximumDrawdown.doubleValue();
        }

        /**
         * 
         * @param {*} series
         * @param {*} tradingRecord
         * @return {number}
         */
        public calculate(series? : any, tradingRecord? : any) : any {
            if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series, tradingRecord);
            } else if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && tradingRecord instanceof <any>org.ta4j.core.Trade) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, tradingRecord);
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            if(trade != null && trade.getEntry() != null && trade.getExit() != null) {
                let cashFlow : org.ta4j.core.analysis.CashFlow = new org.ta4j.core.analysis.CashFlow(series, trade);
                let maximumDrawdown : org.ta4j.core.Decimal = this.calculateMaximumDrawdown(series, cashFlow);
                return maximumDrawdown.doubleValue();
            }
            return 0;
        }

        /**
         * 
         * @param {number} criterionValue1
         * @param {number} criterionValue2
         * @return {boolean}
         */
        public betterThan(criterionValue1 : number, criterionValue2 : number) : boolean {
            return criterionValue1 < criterionValue2;
        }

        /**
         * Calculates the maximum drawdown from a cash flow over a series.
         * @param {*} series the time series
         * @param {org.ta4j.core.analysis.CashFlow} cashFlow the cash flow
         * @return {org.ta4j.core.Decimal} the maximum drawdown from a cash flow over a series
         * @private
         */
        /*private*/ calculateMaximumDrawdown(series : org.ta4j.core.TimeSeries, cashFlow : org.ta4j.core.analysis.CashFlow) : org.ta4j.core.Decimal {
            let maximumDrawdown : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            let maxPeak : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            if(!series.isEmpty()) {
                for(let i : number = series.getBeginIndex(); i <= series.getEndIndex(); i++) {
                    let value : org.ta4j.core.Decimal = cashFlow.getValue(i);
                    if(value.isGreaterThan(maxPeak)) {
                        maxPeak = value;
                    }
                    let drawdown : org.ta4j.core.Decimal = maxPeak.minus(value).dividedBy(maxPeak);
                    if(drawdown.isGreaterThan(maximumDrawdown)) {
                        maximumDrawdown = drawdown;
                    }
                };
            }
            return maximumDrawdown;
        }

        constructor() {
            super();
        }
    }
    MaximumDrawdownCriterion["__class"] = "org.ta4j.core.analysis.criteria.MaximumDrawdownCriterion";
    MaximumDrawdownCriterion["__interfaces"] = ["org.ta4j.core.AnalysisCriterion"];


}

