/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.analysis.criteria {
    /**
     * Total profit criterion.
     * <p></p>
     * The total profit of the provided {@link Trade} over the provided {@link TimeSeries}.
     * @class
     * @extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion
     */
    export class TotalProfitCriterion extends org.ta4j.core.analysis.criteria.AbstractAnalysisCriterion {
        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series : org.ta4j.core.TimeSeries, tradingRecord : org.ta4j.core.TradingRecord) : number {
            let value : number = 1.0;
            {
                let array128 = tradingRecord.getTrades();
                for(let index127=0; index127 < array128.length; index127++) {
                    let trade = array128[index127];
                    {
                        value *= this.calculateProfit(series, trade);
                    }
                }
            }
            return value;
        }

        /**
         * 
         * @param {*} series
         * @param {*} tradingRecord
         * @return {number}
         */
        public calculate(series? : any, tradingRecord? : any) : any {
            if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_TradingRecord(series, tradingRecord);
            } else if(((series != null && (series["__interfaces"] != null && series["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0 || series.constructor != null && series.constructor["__interfaces"] != null && series.constructor["__interfaces"].indexOf("org.ta4j.core.TimeSeries") >= 0)) || series === null) && ((tradingRecord != null && tradingRecord instanceof <any>org.ta4j.core.Trade) || tradingRecord === null)) {
                return <any>this.calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series, tradingRecord);
            } else throw new Error('invalid overload');
        }

        public calculate$org_ta4j_core_TimeSeries$org_ta4j_core_Trade(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            return this.calculateProfit(series, trade);
        }

        /**
         * 
         * @param {number} criterionValue1
         * @param {number} criterionValue2
         * @return {boolean}
         */
        public betterThan(criterionValue1 : number, criterionValue2 : number) : boolean {
            return criterionValue1 > criterionValue2;
        }

        /**
         * Calculates the profit of a trade (Buy and sell).
         * @param {*} series a time series
         * @param {org.ta4j.core.Trade} trade a trade
         * @return {number} the profit of the trade
         * @private
         */
        /*private*/ calculateProfit(series : org.ta4j.core.TimeSeries, trade : org.ta4j.core.Trade) : number {
            let profit : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ONE_$LI$();
            if(trade.isClosed()) {
                let exitClosePrice : org.ta4j.core.Decimal = trade.getExit().getPrice().isNaN()?series.getBar(trade.getExit().getIndex()).getClosePrice():trade.getExit().getPrice();
                let entryClosePrice : org.ta4j.core.Decimal = trade.getEntry().getPrice().isNaN()?series.getBar(trade.getEntry().getIndex()).getClosePrice():trade.getEntry().getPrice();
                if(trade.getEntry().isBuy()) {
                    profit = exitClosePrice.dividedBy(entryClosePrice);
                } else {
                    profit = entryClosePrice.dividedBy(exitClosePrice);
                }
            }
            return profit.doubleValue();
        }

        constructor() {
            super();
        }
    }
    TotalProfitCriterion["__class"] = "org.ta4j.core.analysis.criteria.TotalProfitCriterion";
    TotalProfitCriterion["__interfaces"] = ["org.ta4j.core.AnalysisCriterion"];


}

