/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators {
    /**
     * Constructor.
     * 
     * @param {*} price the price
     * @param {number} timeFrameEffectiveRatio the time frame of the effective ratio (usually 10)
     * @param {number} timeFrameFast the time frame fast (usually 2)
     * @param {number} timeFrameSlow the time frame slow (usually 30)
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class KAMAIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ price : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /*private*/ timeFrameEffectiveRatio : number;

        /*private*/ fastest : org.ta4j.core.Decimal;

        /*private*/ slowest : org.ta4j.core.Decimal;

        public constructor(price : org.ta4j.core.Indicator<org.ta4j.core.Decimal>, timeFrameEffectiveRatio : number, timeFrameFast : number, timeFrameSlow : number) {
            super(price);
            if(this.price===undefined) this.price = null;
            if(this.timeFrameEffectiveRatio===undefined) this.timeFrameEffectiveRatio = 0;
            if(this.fastest===undefined) this.fastest = null;
            if(this.slowest===undefined) this.slowest = null;
            this.price = price;
            this.timeFrameEffectiveRatio = timeFrameEffectiveRatio;
            this.fastest = org.ta4j.core.Decimal.TWO_$LI$().dividedBy(org.ta4j.core.Decimal.valueOf$int(timeFrameFast + 1));
            this.slowest = org.ta4j.core.Decimal.TWO_$LI$().dividedBy(org.ta4j.core.Decimal.valueOf$int(timeFrameSlow + 1));
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let currentPrice : org.ta4j.core.Decimal = this.price.getValue(index);
            if(index < this.timeFrameEffectiveRatio) {
                return currentPrice;
            }
            let startChangeIndex : number = Math.max(0, index - this.timeFrameEffectiveRatio);
            let change : org.ta4j.core.Decimal = currentPrice.minus(this.price.getValue(startChangeIndex)).abs();
            let volatility : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            for(let i : number = startChangeIndex; i < index; i++) {
                volatility = volatility.plus(this.price.getValue(i + 1).minus(this.price.getValue(i)).abs());
            };
            let er : org.ta4j.core.Decimal = change.dividedBy(volatility);
            let sc : org.ta4j.core.Decimal = er.multipliedBy(this.fastest.minus(this.slowest)).plus(this.slowest).pow(2);
            let priorKAMA : org.ta4j.core.Decimal = this.getValue(index - 1);
            return priorKAMA.plus(sc.multipliedBy(currentPrice.minus(priorKAMA)));
        }
    }
    KAMAIndicator["__class"] = "org.ta4j.core.indicators.KAMAIndicator";
    KAMAIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

