/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators {
    /**
     * Constructor.
     * @param {*} series the time series
     * @param {number} emaTimeFrame the time frame for EMAs (usually 9)
     * @param {number} timeFrame the time frame
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class MassIndexIndicator extends org.ta4j.core.indicators.CachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ singleEma : org.ta4j.core.indicators.EMAIndicator;

        /*private*/ doubleEma : org.ta4j.core.indicators.EMAIndicator;

        /*private*/ timeFrame : number;

        public constructor(series : org.ta4j.core.TimeSeries, emaTimeFrame : number, timeFrame : number) {
            super(series);
            if(this.singleEma===undefined) this.singleEma = null;
            if(this.doubleEma===undefined) this.doubleEma = null;
            if(this.timeFrame===undefined) this.timeFrame = 0;
            let highLowDifferential : org.ta4j.core.Indicator<org.ta4j.core.Decimal> = new org.ta4j.core.indicators.helpers.DifferenceIndicator(new org.ta4j.core.indicators.helpers.MaxPriceIndicator(series), new org.ta4j.core.indicators.helpers.MinPriceIndicator(series));
            this.singleEma = new org.ta4j.core.indicators.EMAIndicator(highLowDifferential, emaTimeFrame);
            this.doubleEma = new org.ta4j.core.indicators.EMAIndicator(this.singleEma, emaTimeFrame);
            this.timeFrame = timeFrame;
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let startIndex : number = Math.max(0, index - this.timeFrame + 1);
            let massIndex : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            for(let i : number = startIndex; i <= index; i++) {
                let emaRatio : org.ta4j.core.Decimal = this.singleEma.getValue(i).dividedBy(this.doubleEma.getValue(i));
                massIndex = massIndex.plus(emaRatio);
            };
            return massIndex;
        }
    }
    MassIndexIndicator["__class"] = "org.ta4j.core.indicators.MassIndexIndicator";
    MassIndexIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

