/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators {
    /**
     * Relative strength index indicator.
     * <p>
     * Computed using original Welles Wilder formula.
     * @param {*} indicator
     * @param {number} timeFrame
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class RSIIndicator extends org.ta4j.core.indicators.CachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ averageGainIndicator : org.ta4j.core.indicators.MMAIndicator;

        /*private*/ averageLossIndicator : org.ta4j.core.indicators.MMAIndicator;

        public constructor(indicator : org.ta4j.core.Indicator<org.ta4j.core.Decimal>, timeFrame : number) {
            super(indicator);
            if(this.averageGainIndicator===undefined) this.averageGainIndicator = null;
            if(this.averageLossIndicator===undefined) this.averageLossIndicator = null;
            this.averageGainIndicator = new org.ta4j.core.indicators.MMAIndicator(new org.ta4j.core.indicators.helpers.GainIndicator(indicator), timeFrame);
            this.averageLossIndicator = new org.ta4j.core.indicators.MMAIndicator(new org.ta4j.core.indicators.helpers.LossIndicator(indicator), timeFrame);
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let averageGain : org.ta4j.core.Decimal = this.averageGainIndicator.getValue(index);
            let averageLoss : org.ta4j.core.Decimal = this.averageLossIndicator.getValue(index);
            if(averageLoss.isZero()) {
                if(averageGain.isZero()) {
                    return org.ta4j.core.Decimal.ZERO_$LI$();
                } else {
                    return org.ta4j.core.Decimal.HUNDRED_$LI$();
                }
            }
            let relativeStrength : org.ta4j.core.Decimal = averageGain.dividedBy(averageLoss);
            return org.ta4j.core.Decimal.HUNDRED_$LI$().minus(org.ta4j.core.Decimal.HUNDRED_$LI$().dividedBy(org.ta4j.core.Decimal.ONE_$LI$().plus(relativeStrength)));
        }
    }
    RSIIndicator["__class"] = "org.ta4j.core.indicators.RSIIndicator";
    RSIIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

