/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators {
    /**
     * Zero-lag exponential moving average indicator.
     * <p></p>
     * @see <a href="http://www.fmlabs.com/reference/default.htm?url=ZeroLagExpMA.htm">
     * href="http://www.fmlabs.com/reference/default.htm?url=ZeroLagExpMA.htm</a>
     * @param {*} indicator
     * @param {number} timeFrame
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class ZLEMAIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ indicator : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /*private*/ timeFrame : number;

        /*private*/ k : org.ta4j.core.Decimal;

        /*private*/ lag : number;

        public constructor(indicator : org.ta4j.core.Indicator<org.ta4j.core.Decimal>, timeFrame : number) {
            super(indicator);
            if(this.indicator===undefined) this.indicator = null;
            if(this.timeFrame===undefined) this.timeFrame = 0;
            if(this.k===undefined) this.k = null;
            if(this.lag===undefined) this.lag = 0;
            this.indicator = indicator;
            this.timeFrame = timeFrame;
            this.k = org.ta4j.core.Decimal.TWO_$LI$().dividedBy(org.ta4j.core.Decimal.valueOf$int(timeFrame + 1));
            this.lag = ((timeFrame - 1) / 2|0);
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            if(index + 1 < this.timeFrame) {
                return new org.ta4j.core.indicators.SMAIndicator(this.indicator, this.timeFrame).getValue(index);
            }
            if(index === 0) {
                return this.indicator.getValue(0);
            }
            let zlemaPrev : org.ta4j.core.Decimal = this.getValue(index - 1);
            return this.k.multipliedBy(org.ta4j.core.Decimal.TWO_$LI$().multipliedBy(this.indicator.getValue(index)).minus(this.indicator.getValue(index - this.lag))).plus(org.ta4j.core.Decimal.ONE_$LI$().minus(this.k).multipliedBy(zlemaPrev));
        }

        /**
         * 
         * @return {string}
         */
        public toString() : string {
            return /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor)) + " timeFrame: " + this.timeFrame;
        }
    }
    ZLEMAIndicator["__class"] = "org.ta4j.core.indicators.ZLEMAIndicator";
    ZLEMAIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

