/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.candles {
    /**
     * Constructor.
     * @param {*} series a time series
     * @param {number} timeFrame the number of bars used to calculate the average body height
     * @param {org.ta4j.core.Decimal} bodyFactor the factor used when checking if a candle is Doji
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class DojiIndicator extends org.ta4j.core.indicators.CachedIndicator<boolean> {
        /**
         * Body height
         */
        /*private*/ bodyHeightInd : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /**
         * Average body height
         */
        /*private*/ averageBodyHeightInd : org.ta4j.core.indicators.SMAIndicator;

        /*private*/ factor : org.ta4j.core.Decimal;

        public constructor(series : org.ta4j.core.TimeSeries, timeFrame : number, bodyFactor : org.ta4j.core.Decimal) {
            super(series);
            if(this.bodyHeightInd===undefined) this.bodyHeightInd = null;
            if(this.averageBodyHeightInd===undefined) this.averageBodyHeightInd = null;
            if(this.factor===undefined) this.factor = null;
            this.bodyHeightInd = new org.ta4j.core.indicators.helpers.AbsoluteIndicator(new org.ta4j.core.indicators.candles.RealBodyIndicator(series));
            this.averageBodyHeightInd = new org.ta4j.core.indicators.SMAIndicator(this.bodyHeightInd, timeFrame);
            this.factor = bodyFactor;
        }

        /**
         * 
         * @param {number} index
         * @return {boolean}
         */
        calculate(index : number) : boolean {
            if(index < 1) {
                return this.bodyHeightInd.getValue(index).isZero();
            }
            let averageBodyHeight : org.ta4j.core.Decimal = this.averageBodyHeightInd.getValue(index - 1);
            let currentBodyHeight : org.ta4j.core.Decimal = this.bodyHeightInd.getValue(index);
            return currentBodyHeight.isLessThan(averageBodyHeight.multipliedBy(this.factor));
        }
    }
    DojiIndicator["__class"] = "org.ta4j.core.indicators.candles.DojiIndicator";
    DojiIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

