/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.candles {
    /**
     * Constructor.
     * @param {*} series a time series
     * @param {number} timeFrame the number of bars used to calculate the average lower shadow
     * @param {org.ta4j.core.Decimal} factor the factor used when checking if a candle has a very short lower shadow
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class ThreeBlackCrowsIndicator extends org.ta4j.core.indicators.CachedIndicator<boolean> {
        /*private*/ __org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series : org.ta4j.core.TimeSeries;

        /**
         * Lower shadow
         */
        /*private*/ lowerShadowInd : org.ta4j.core.indicators.candles.LowerShadowIndicator;

        /**
         * Average lower shadow
         */
        /*private*/ averageLowerShadowInd : org.ta4j.core.indicators.SMAIndicator;

        /**
         * Factor used when checking if a candle has a very short lower shadow
         */
        /*private*/ factor : org.ta4j.core.Decimal;

        /*private*/ whiteCandleIndex : number = -1;

        public constructor(series : org.ta4j.core.TimeSeries, timeFrame : number, factor : org.ta4j.core.Decimal) {
            super(series);
            if(this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series===undefined) this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series = null;
            if(this.lowerShadowInd===undefined) this.lowerShadowInd = null;
            if(this.averageLowerShadowInd===undefined) this.averageLowerShadowInd = null;
            if(this.factor===undefined) this.factor = null;
            this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series = series;
            this.lowerShadowInd = new org.ta4j.core.indicators.candles.LowerShadowIndicator(series);
            this.averageLowerShadowInd = new org.ta4j.core.indicators.SMAIndicator(this.lowerShadowInd, timeFrame);
            this.factor = factor;
        }

        /**
         * 
         * @param {number} index
         * @return {boolean}
         */
        calculate(index : number) : boolean {
            if(index < 3) {
                return false;
            }
            this.whiteCandleIndex = index - 3;
            return this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series.getBar(this.whiteCandleIndex).isBullish() && this.isBlackCrow(index - 2) && this.isBlackCrow(index - 1) && this.isBlackCrow(index);
        }

        /**
         * @param {number} index the bar/candle index
         * @return {boolean} true if the bar/candle has a very short lower shadow, false otherwise
         * @private
         */
        /*private*/ hasVeryShortLowerShadow(index : number) : boolean {
            let currentLowerShadow : org.ta4j.core.Decimal = this.lowerShadowInd.getValue(index);
            let averageLowerShadow : org.ta4j.core.Decimal = this.averageLowerShadowInd.getValue(this.whiteCandleIndex);
            return currentLowerShadow.isLessThan(averageLowerShadow.multipliedBy(this.factor));
        }

        /**
         * @param {number} index the current bar/candle index
         * @return {boolean} true if the current bar/candle is declining, false otherwise
         * @private
         */
        /*private*/ isDeclining(index : number) : boolean {
            let prevBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series.getBar(index - 1);
            let currBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series.getBar(index);
            let prevOpenPrice : org.ta4j.core.Decimal = prevBar.getOpenPrice();
            let prevClosePrice : org.ta4j.core.Decimal = prevBar.getClosePrice();
            let currOpenPrice : org.ta4j.core.Decimal = currBar.getOpenPrice();
            let currClosePrice : org.ta4j.core.Decimal = currBar.getClosePrice();
            return currOpenPrice.isLessThan(prevOpenPrice) && currOpenPrice.isGreaterThan(prevClosePrice) && currClosePrice.isLessThan(prevClosePrice);
        }

        /**
         * @param {number} index the current bar/candle index
         * @return {boolean} true if the current bar/candle is a black crow, false otherwise
         * @private
         */
        /*private*/ isBlackCrow(index : number) : boolean {
            let prevBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series.getBar(index - 1);
            let currBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeBlackCrowsIndicator_series.getBar(index);
            if(currBar.isBearish()) {
                if(prevBar.isBullish()) {
                    return this.hasVeryShortLowerShadow(index) && currBar.getOpenPrice().isLessThan(prevBar.getMaxPrice());
                } else {
                    return this.hasVeryShortLowerShadow(index) && this.isDeclining(index);
                }
            }
            return false;
        }
    }
    ThreeBlackCrowsIndicator["__class"] = "org.ta4j.core.indicators.candles.ThreeBlackCrowsIndicator";
    ThreeBlackCrowsIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

