/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.candles {
    /**
     * Constructor.
     * @param {*} series a time series
     * @param {number} timeFrame the number of bars used to calculate the average upper shadow
     * @param {org.ta4j.core.Decimal} factor the factor used when checking if a candle has a very short upper shadow
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class ThreeWhiteSoldiersIndicator extends org.ta4j.core.indicators.CachedIndicator<boolean> {
        /*private*/ __org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series : org.ta4j.core.TimeSeries;

        /**
         * Upper shadow
         */
        /*private*/ upperShadowInd : org.ta4j.core.indicators.candles.UpperShadowIndicator;

        /**
         * Average upper shadow
         */
        /*private*/ averageUpperShadowInd : org.ta4j.core.indicators.SMAIndicator;

        /**
         * Factor used when checking if a candle has a very short upper shadow
         */
        /*private*/ factor : org.ta4j.core.Decimal;

        /*private*/ blackCandleIndex : number = -1;

        public constructor(series : org.ta4j.core.TimeSeries, timeFrame : number, factor : org.ta4j.core.Decimal) {
            super(series);
            if(this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series===undefined) this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series = null;
            if(this.upperShadowInd===undefined) this.upperShadowInd = null;
            if(this.averageUpperShadowInd===undefined) this.averageUpperShadowInd = null;
            if(this.factor===undefined) this.factor = null;
            this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series = series;
            this.upperShadowInd = new org.ta4j.core.indicators.candles.UpperShadowIndicator(series);
            this.averageUpperShadowInd = new org.ta4j.core.indicators.SMAIndicator(this.upperShadowInd, timeFrame);
            this.factor = factor;
        }

        /**
         * 
         * @param {number} index
         * @return {boolean}
         */
        calculate(index : number) : boolean {
            if(index < 3) {
                return false;
            }
            this.blackCandleIndex = index - 3;
            return this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series.getBar(this.blackCandleIndex).isBearish() && this.isWhiteSoldier(index - 2) && this.isWhiteSoldier(index - 1) && this.isWhiteSoldier(index);
        }

        /**
         * @param {number} index the bar/candle index
         * @return {boolean} true if the bar/candle has a very short upper shadow, false otherwise
         * @private
         */
        /*private*/ hasVeryShortUpperShadow(index : number) : boolean {
            let currentUpperShadow : org.ta4j.core.Decimal = this.upperShadowInd.getValue(index);
            let averageUpperShadow : org.ta4j.core.Decimal = this.averageUpperShadowInd.getValue(this.blackCandleIndex);
            return currentUpperShadow.isLessThan(averageUpperShadow.multipliedBy(this.factor));
        }

        /**
         * @param {number} index the current bar/candle index
         * @return {boolean} true if the current bar/candle is growing, false otherwise
         * @private
         */
        /*private*/ isGrowing(index : number) : boolean {
            let prevBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series.getBar(index - 1);
            let currBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series.getBar(index);
            let prevOpenPrice : org.ta4j.core.Decimal = prevBar.getOpenPrice();
            let prevClosePrice : org.ta4j.core.Decimal = prevBar.getClosePrice();
            let currOpenPrice : org.ta4j.core.Decimal = currBar.getOpenPrice();
            let currClosePrice : org.ta4j.core.Decimal = currBar.getClosePrice();
            return currOpenPrice.isGreaterThan(prevOpenPrice) && currOpenPrice.isLessThan(prevClosePrice) && currClosePrice.isGreaterThan(prevClosePrice);
        }

        /**
         * @param {number} index the current bar/candle index
         * @return {boolean} true if the current bar/candle is a white soldier, false otherwise
         * @private
         */
        /*private*/ isWhiteSoldier(index : number) : boolean {
            let prevBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series.getBar(index - 1);
            let currBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_candles_ThreeWhiteSoldiersIndicator_series.getBar(index);
            if(currBar.isBullish()) {
                if(prevBar.isBearish()) {
                    return this.hasVeryShortUpperShadow(index) && currBar.getOpenPrice().isGreaterThan(prevBar.getMinPrice());
                } else {
                    return this.hasVeryShortUpperShadow(index) && this.isGrowing(index);
                }
            }
            return false;
        }
    }
    ThreeWhiteSoldiersIndicator["__class"] = "org.ta4j.core.indicators.candles.ThreeWhiteSoldiersIndicator";
    ThreeWhiteSoldiersIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

