/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.helpers {
    /**
     * Constructor. <br/>
     * <br/>
     * 
     * The <b>"minStrenght"</b> is the minimum required strenght for convergence or divergence
     * and must be a number between "0.1" and "1.0": <br/>
     * <br/>
     * 0.1: very weak <br/>
     * 0.8: strong (recommended) <br/>
     * 1.0: very strong <br/>
     * 
     * <br/>
     * 
     * The <b>"minSlope"</b> is the minimum required slope for convergence or divergence
     * and must be a number between "0.1" and "1.0": <br/>
     * <br/>
     * 0.1: very unstrict<br/>
     * 0.3: strict (recommended) <br/>
     * 1.0: very strict <br/>
     * 
     * @param {*} ref the indicator
     * @param {*} other the other indicator
     * @param {number} timeFrame the time frame
     * @param {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType} type of convergence or divergence
     * @param {number} minStrenght the minimum required strenght for convergence or divergence
     * @param {number} minSlope the minimum required slope for convergence or divergence
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class ConvergenceDivergenceIndicator extends org.ta4j.core.indicators.CachedIndicator<boolean> {
        static serialVersionUID : number = -6735646430246479066;

        /**
         * The actual indicator.
         */
        /*private*/ ref : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /**
         * The other indicator.
         */
        /*private*/ other : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /**
         * The timeFrame.
         */
        /*private*/ timeFrame : number;

        /**
         * The type of the convergence or divergence
         */
        /*private*/ type : ConvergenceDivergenceIndicator.ConvergenceDivergenceType;

        /**
         * The type of the strict convergence or strict divergence
         */
        /*private*/ strictType : ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType;

        /**
         * The minimum strenght for convergence or divergence.
         */
        /*private*/ minStrenght : org.ta4j.core.Decimal;

        /**
         * The minimum slope for convergence or divergence.
         */
        /*private*/ minSlope : org.ta4j.core.Decimal;

        public constructor(ref? : any, other? : any, timeFrame? : any, type? : any, minStrenght? : any, minSlope? : any) {
            if(((ref != null && (ref["__interfaces"] != null && ref["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || ref.constructor != null && ref.constructor["__interfaces"] != null && ref.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || ref === null) && ((other != null && (other["__interfaces"] != null && other["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || other.constructor != null && other.constructor["__interfaces"] != null && other.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || other === null) && ((typeof timeFrame === 'number') || timeFrame === null) && ((typeof type === 'number') || type === null) && ((typeof minStrenght === 'number') || minStrenght === null) && ((typeof minSlope === 'number') || minSlope === null)) {
                let __args = Array.prototype.slice.call(arguments);
                super(ref);
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                (() => {
                    this.ref = ref;
                    this.other = other;
                    this.timeFrame = timeFrame;
                    this.type = type;
                    this.strictType = null;
                    this.minStrenght = org.ta4j.core.Decimal.valueOf$double(minStrenght).abs();
                    this.minSlope = org.ta4j.core.Decimal.valueOf$double(minSlope);
                })();
            } else if(((ref != null && (ref["__interfaces"] != null && ref["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || ref.constructor != null && ref.constructor["__interfaces"] != null && ref.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || ref === null) && ((other != null && (other["__interfaces"] != null && other["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || other.constructor != null && other.constructor["__interfaces"] != null && other.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || other === null) && ((typeof timeFrame === 'number') || timeFrame === null) && ((typeof type === 'number') || type === null) && minStrenght === undefined && minSlope === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                super(ref);
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                (() => {
                    this.ref = ref;
                    this.other = other;
                    this.timeFrame = timeFrame;
                    this.type = type;
                    this.strictType = null;
                    this.minStrenght = org.ta4j.core.Decimal.valueOf$double(0.8).abs();
                    this.minSlope = org.ta4j.core.Decimal.valueOf$double(0.3);
                })();
            } else if(((ref != null && (ref["__interfaces"] != null && ref["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || ref.constructor != null && ref.constructor["__interfaces"] != null && ref.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || ref === null) && ((other != null && (other["__interfaces"] != null && other["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0 || other.constructor != null && other.constructor["__interfaces"] != null && other.constructor["__interfaces"].indexOf("org.ta4j.core.Indicator") >= 0)) || other === null) && ((typeof timeFrame === 'number') || timeFrame === null) && ((typeof type === 'number') || type === null) && minStrenght === undefined && minSlope === undefined) {
                let __args = Array.prototype.slice.call(arguments);
                let strictType : any = __args[3];
                super(ref);
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                if(this.ref===undefined) this.ref = null;
                if(this.other===undefined) this.other = null;
                if(this.timeFrame===undefined) this.timeFrame = 0;
                if(this.type===undefined) this.type = null;
                if(this.strictType===undefined) this.strictType = null;
                if(this.minStrenght===undefined) this.minStrenght = null;
                if(this.minSlope===undefined) this.minSlope = null;
                (() => {
                    this.ref = ref;
                    this.other = other;
                    this.timeFrame = timeFrame;
                    this.type = null;
                    this.strictType = strictType;
                    this.minStrenght = null;
                    this.minSlope = null;
                })();
            } else throw new Error('invalid overload');
        }

        /**
         * 
         * @param {number} index
         * @return {boolean}
         */
        calculate(index : number) : boolean {
            if(this.minStrenght.isZero()) {
                return false;
            }
            if(this.minStrenght.isGreaterThan(org.ta4j.core.Decimal.ONE_$LI$())) {
                this.minStrenght = org.ta4j.core.Decimal.ONE_$LI$();
            }
            if(this.type != null) {
                switch((this.type)) {
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType.positiveConvergent:
                    return this.calculatePositiveConvergence(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType.negativeConvergent:
                    return this.calculateNegativeConvergence(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType.positiveDivergent:
                    return this.calculatePositiveDivergence(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType.negativeDivergent:
                    return this.calculateNegativeDivergence(index);
                default:
                    return false;
                }
            } else if(this.strictType != null) {
                switch((this.strictType)) {
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType.positiveConvergentStrict:
                    return this.calculatePositiveConvergenceStrict(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType.negativeConvergentStrict:
                    return this.calculateNegativeConvergenceStrict(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType.positiveDivergentStrict:
                    return this.calculatePositiveDivergenceStrict(index);
                case org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType.negativeDivergentStrict:
                    return this.calculateNegativeDivergenceStrict(index);
                default:
                    return false;
                }
            }
            return false;
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if strict positive convergent
         * @private
         */
        calculatePositiveConvergenceStrict(index : number) : boolean {
            let refIsRising : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsRisingRule(this.ref, this.timeFrame);
            let otherIsRising : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsRisingRule(this.ref, this.timeFrame);
            return (refIsRising.and(otherIsRising))['isSatisfied$int'](index);
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if strict negative convergent
         * @private
         */
        calculateNegativeConvergenceStrict(index : number) : boolean {
            let refIsFalling : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsFallingRule(this.ref, this.timeFrame);
            let otherIsFalling : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsFallingRule(this.ref, this.timeFrame);
            return (refIsFalling.and(otherIsFalling))['isSatisfied$int'](index);
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if positive divergent
         * @private
         */
        calculatePositiveDivergenceStrict(index : number) : boolean {
            let refIsRising : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsRisingRule(this.ref, this.timeFrame);
            let otherIsFalling : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsFallingRule(this.ref, this.timeFrame);
            return (refIsRising.and(otherIsFalling))['isSatisfied$int'](index);
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if negative divergent
         * @private
         */
        calculateNegativeDivergenceStrict(index : number) : boolean {
            let refIsFalling : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsFallingRule(this.ref, this.timeFrame);
            let otherIsRising : org.ta4j.core.Rule = new org.ta4j.core.trading.rules.IsRisingRule(this.ref, this.timeFrame);
            return (refIsFalling.and(otherIsRising))['isSatisfied$int'](index);
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if positive convergent
         * @private
         */
        calculatePositiveConvergence(index : number) : boolean {
            let cc : org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator = new org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator(this.ref, this.other, this.timeFrame);
            let isConvergent : boolean = cc.getValue(index).isGreaterThanOrEqual(this.minStrenght);
            let slope : org.ta4j.core.Decimal = this.calculateSlopeRel(index);
            let isPositive : boolean = slope.isGreaterThanOrEqual(this.minSlope.abs());
            return isConvergent && isPositive;
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if negative convergent
         * @private
         */
        calculateNegativeConvergence(index : number) : boolean {
            let cc : org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator = new org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator(this.ref, this.other, this.timeFrame);
            let isConvergent : boolean = cc.getValue(index).isGreaterThanOrEqual(this.minStrenght);
            let slope : org.ta4j.core.Decimal = this.calculateSlopeRel(index);
            let isNegative : boolean = slope.isLessThanOrEqual(this.minSlope.abs().multipliedBy(org.ta4j.core.Decimal.valueOf$int(-1)));
            return isConvergent && isNegative;
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if positive divergent
         * @private
         */
        calculatePositiveDivergence(index : number) : boolean {
            let cc : org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator = new org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator(this.ref, this.other, this.timeFrame);
            let isDivergent : boolean = cc.getValue(index).isLessThanOrEqual(this.minStrenght.multipliedBy(org.ta4j.core.Decimal.valueOf$int(-1)));
            if(isDivergent) {
                let slope : org.ta4j.core.Decimal = this.calculateSlopeRel(index);
                return slope.isGreaterThanOrEqual(this.minSlope.abs());
            }
            return false;
        }

        /**
         * @param {number} index the actual index
         * @return {boolean} true, if negative divergent
         * @private
         */
        calculateNegativeDivergence(index : number) : boolean {
            let cc : org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator = new org.ta4j.core.indicators.statistics.CorrelationCoefficientIndicator(this.ref, this.other, this.timeFrame);
            let isDivergent : boolean = cc.getValue(index).isLessThanOrEqual(this.minStrenght.multipliedBy(org.ta4j.core.Decimal.valueOf$int(-1)));
            if(isDivergent) {
                let slope : org.ta4j.core.Decimal = this.calculateSlopeRel(index);
                return slope.isLessThanOrEqual(this.minSlope.abs().multipliedBy(org.ta4j.core.Decimal.valueOf$int(-1)));
            }
            return false;
        }

        /**
         * @param {number} index the actual index
         * @return {org.ta4j.core.Decimal} the absolute slope
         * @private
         */
        calculateSlopeAbs(index : number) : org.ta4j.core.Decimal {
            let slrRef : org.ta4j.core.indicators.statistics.SimpleLinearRegressionIndicator = new org.ta4j.core.indicators.statistics.SimpleLinearRegressionIndicator(this.ref, this.timeFrame);
            let firstIndex : number = Math.max(0, index - this.timeFrame + 1);
            return (slrRef.getValue(index).minus(slrRef.getValue(firstIndex))).dividedBy(org.ta4j.core.Decimal.valueOf$int(this.timeFrame).minus(org.ta4j.core.Decimal.valueOf$int(firstIndex)));
        }

        /**
         * @param {number} index the actual index
         * @return {org.ta4j.core.Decimal} the relative slope
         * @private
         */
        calculateSlopeRel(index : number) : org.ta4j.core.Decimal {
            let slrRef : org.ta4j.core.indicators.statistics.SimpleLinearRegressionIndicator = new org.ta4j.core.indicators.statistics.SimpleLinearRegressionIndicator(this.ref, this.timeFrame);
            let firstIndex : number = Math.max(0, index - this.timeFrame + 1);
            return (slrRef.getValue(index).minus(slrRef.getValue(firstIndex))).dividedBy(slrRef.getValue(index));
        }
    }
    ConvergenceDivergenceIndicator["__class"] = "org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator";
    ConvergenceDivergenceIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];



    export namespace ConvergenceDivergenceIndicator {

        /**
         * Select the type of convergence or divergence.
         * @enum
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType} positiveConvergent
         * Returns true for <b>"positiveConvergent"</b> when the values of the
         * ref-{@link Indicator} and the values of the
         * other-{@link Indicator} increase within the timeFrame. In
         * short: "other" and "ref" makes higher highs.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType} negativeConvergent
         * Returns true for <b>"negativeConvergent"</b> when the values of the
         * ref-{@link Indicator} and the values of the
         * other-{@link Indicator} decrease within the timeFrame. In
         * short: "other" and "ref" makes lower lows.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType} positiveDivergent
         * Returns true for <b>"positiveDivergent"</b> when the values of the
         * ref-{@link Indicator} increase and the values of the
         * other-{@link Indicator} decrease within a timeFrame. In
         * short: "other" makes lower lows while "ref" makes higher highs.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceType} negativeDivergent
         * Returns true for <b>"negativeDivergent"</b> when the values of the
         * ref-{@link Indicator} decrease and the values of the
         * other-{@link Indicator} increase within a timeFrame. In
         * short: "other" makes higher highs while "ref" makes lower lows.
         * @class
         */
        export enum ConvergenceDivergenceType {
            
            /**
             * Returns true for <b>"positiveConvergent"</b> when the values of the
             * ref-{@link Indicator} and the values of the
             * other-{@link Indicator} increase within the timeFrame. In
             * short: "other" and "ref" makes higher highs.
             */
            positiveConvergent, 
            /**
             * Returns true for <b>"negativeConvergent"</b> when the values of the
             * ref-{@link Indicator} and the values of the
             * other-{@link Indicator} decrease within the timeFrame. In
             * short: "other" and "ref" makes lower lows.
             */
            negativeConvergent, 
            /**
             * Returns true for <b>"positiveDivergent"</b> when the values of the
             * ref-{@link Indicator} increase and the values of the
             * other-{@link Indicator} decrease within a timeFrame. In
             * short: "other" makes lower lows while "ref" makes higher highs.
             */
            positiveDivergent, 
            /**
             * Returns true for <b>"negativeDivergent"</b> when the values of the
             * ref-{@link Indicator} decrease and the values of the
             * other-{@link Indicator} increase within a timeFrame. In
             * short: "other" makes higher highs while "ref" makes lower lows.
             */
            negativeDivergent
        }

        /**
         * Select the type of strict convergence or divergence.
         * @enum
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType} positiveConvergentStrict
         * Returns true for <b>"positiveConvergentStrict"</b> when the values of
         * the ref-{@link Indicator} and the values of the
         * other-{@link Indicator} increase consecutively within a
         * timeFrame. In short: "other" and "ref" makes strict higher highs.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType} negativeConvergentStrict
         * Returns true for <b>"negativeConvergentStrict"</b> when the values of
         * the ref-{@link Indicator} and the values of the
         * other-{@link Indicator} decrease consecutively within a
         * timeFrame. In short: "other" and "ref" makes strict lower lows.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType} positiveDivergentStrict
         * Returns true for <b>"positiveDivergentStrict"</b> when the values of
         * the ref-{@link Indicator} increase consecutively and the
         * values of the other-{@link Indicator} decrease
         * consecutively within a timeFrame. In short: "other" makes strict
         * higher highs and "ref" makes strict lower lows.
         * @property {org.ta4j.core.indicators.helpers.ConvergenceDivergenceIndicator.ConvergenceDivergenceStrictType} negativeDivergentStrict
         * Returns true for <b>"negativeDivergentStrict"</b> when the values of
         * the ref-{@link Indicator} decrease consecutively and the
         * values of the other-{@link Indicator} increase
         * consecutively within a timeFrame. In short: "other" makes strict
         * lower lows and "ref" makes strict higher highs.
         * @class
         */
        export enum ConvergenceDivergenceStrictType {
            
            /**
             * Returns true for <b>"positiveConvergentStrict"</b> when the values of
             * the ref-{@link Indicator} and the values of the
             * other-{@link Indicator} increase consecutively within a
             * timeFrame. In short: "other" and "ref" makes strict higher highs.
             */
            positiveConvergentStrict, 
            /**
             * Returns true for <b>"negativeConvergentStrict"</b> when the values of
             * the ref-{@link Indicator} and the values of the
             * other-{@link Indicator} decrease consecutively within a
             * timeFrame. In short: "other" and "ref" makes strict lower lows.
             */
            negativeConvergentStrict, 
            /**
             * Returns true for <b>"positiveDivergentStrict"</b> when the values of
             * the ref-{@link Indicator} increase consecutively and the
             * values of the other-{@link Indicator} decrease
             * consecutively within a timeFrame. In short: "other" makes strict
             * higher highs and "ref" makes strict lower lows.
             */
            positiveDivergentStrict, 
            /**
             * Returns true for <b>"negativeDivergentStrict"</b> when the values of
             * the ref-{@link Indicator} decrease consecutively and the
             * values of the other-{@link Indicator} increase
             * consecutively within a timeFrame. In short: "other" makes strict
             * lower lows and "ref" makes strict higher highs.
             */
            negativeDivergentStrict
        }
    }

}

