/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.pivotpoints {
    /**
     * Constructor.
     * <p>
     * Calculates the DeMark reversal for the corresponding pivot level
     * @param {org.ta4j.core.indicators.pivotpoints.DeMarkPivotPointIndicator} pivotPointIndicator the {@link DeMarkPivotPointIndicator} for this reversal
     * @param {org.ta4j.core.indicators.pivotpoints.DeMarkReversalIndicator.DeMarkPivotLevel} level the {@link DeMarkPivotLevel} for this reversal (RESISTANT, SUPPORT)
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class DeMarkReversalIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ pivotPointIndicator : org.ta4j.core.indicators.pivotpoints.DeMarkPivotPointIndicator;

        /*private*/ level : DeMarkReversalIndicator.DeMarkPivotLevel;

        public constructor(pivotPointIndicator : org.ta4j.core.indicators.pivotpoints.DeMarkPivotPointIndicator, level : DeMarkReversalIndicator.DeMarkPivotLevel) {
            super(pivotPointIndicator);
            if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
            if(this.level===undefined) this.level = null;
            this.pivotPointIndicator = pivotPointIndicator;
            this.level = level;
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let x : org.ta4j.core.Decimal = this.pivotPointIndicator.getValue(index).multipliedBy(org.ta4j.core.Decimal.valueOf$int(4));
            let result : org.ta4j.core.Decimal;
            if(this.level === DeMarkReversalIndicator.DeMarkPivotLevel.SUPPORT) {
                result = this.calculateSupport(x, index);
            } else {
                result = this.calculateResistance(x, index);
            }
            return result;
        }

        calculateResistance(x : org.ta4j.core.Decimal, index : number) : org.ta4j.core.Decimal {
            let barsOfPreviousPeriod : Array<number> = this.pivotPointIndicator.getBarsOfPreviousPeriod(index);
            if(/* isEmpty */(barsOfPreviousPeriod.length == 0)) {
                return org.ta4j.core.Decimal.NaN_$LI$();
            }
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            for(let index140=0; index140 < barsOfPreviousPeriod.length; index140++) {
                let i = barsOfPreviousPeriod[index140];
                {
                    low = this.getTimeSeries().getBar(i).getMinPrice().min(low);
                }
            }
            return x.dividedBy(org.ta4j.core.Decimal.TWO_$LI$()).minus(low);
        }

        calculateSupport(x : org.ta4j.core.Decimal, index : number) : org.ta4j.core.Decimal {
            let barsOfPreviousPeriod : Array<number> = this.pivotPointIndicator.getBarsOfPreviousPeriod(index);
            if(/* isEmpty */(barsOfPreviousPeriod.length == 0)) {
                return org.ta4j.core.Decimal.NaN_$LI$();
            }
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            for(let index141=0; index141 < barsOfPreviousPeriod.length; index141++) {
                let i = barsOfPreviousPeriod[index141];
                {
                    high = this.getTimeSeries().getBar(i).getMaxPrice().max(high);
                }
            }
            return x.dividedBy(org.ta4j.core.Decimal.TWO_$LI$()).minus(high);
        }
    }
    DeMarkReversalIndicator["__class"] = "org.ta4j.core.indicators.pivotpoints.DeMarkReversalIndicator";
    DeMarkReversalIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];



    export namespace DeMarkReversalIndicator {

        export enum DeMarkPivotLevel {
            RESISTANCE, SUPPORT
        }
    }

}

