/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.pivotpoints {
    /**
     * Constructor.
     * <p>
     * Calculates a (fibonacci) reversal
     * @param {org.ta4j.core.indicators.pivotpoints.PivotPointIndicator} pivotPointIndicator the {@link PivotPointIndicator} for this reversal
     * @param {org.ta4j.core.Decimal} fibonacciFactor the fibonacci factor for this reversal
     * @param {org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibReversalTyp} fibReversalTyp the FibonacciReversalIndicator.FibReversalTyp of the reversal (SUPPORT, RESISTANCE)
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class FibonacciReversalIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ pivotPointIndicator : org.ta4j.core.indicators.pivotpoints.PivotPointIndicator;

        /*private*/ fibReversalTyp : FibonacciReversalIndicator.FibReversalTyp;

        /*private*/ fibonacciFactor : org.ta4j.core.Decimal;

        public constructor(pivotPointIndicator? : any, fibonacciFactor? : any, fibReversalTyp? : any) {
            if(((pivotPointIndicator != null && pivotPointIndicator instanceof <any>org.ta4j.core.indicators.pivotpoints.PivotPointIndicator) || pivotPointIndicator === null) && ((fibonacciFactor != null && fibonacciFactor instanceof <any>org.ta4j.core.Decimal) || fibonacciFactor === null) && ((typeof fibReversalTyp === 'number') || fibReversalTyp === null)) {
                let __args = Array.prototype.slice.call(arguments);
                super(pivotPointIndicator);
                if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
                if(this.fibReversalTyp===undefined) this.fibReversalTyp = null;
                if(this.fibonacciFactor===undefined) this.fibonacciFactor = null;
                if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
                if(this.fibReversalTyp===undefined) this.fibReversalTyp = null;
                if(this.fibonacciFactor===undefined) this.fibonacciFactor = null;
                (() => {
                    this.pivotPointIndicator = pivotPointIndicator;
                    this.fibonacciFactor = fibonacciFactor;
                    this.fibReversalTyp = fibReversalTyp;
                })();
            } else if(((pivotPointIndicator != null && pivotPointIndicator instanceof <any>org.ta4j.core.indicators.pivotpoints.PivotPointIndicator) || pivotPointIndicator === null) && ((typeof fibonacciFactor === 'number') || fibonacciFactor === null) && ((typeof fibReversalTyp === 'number') || fibReversalTyp === null)) {
                let __args = Array.prototype.slice.call(arguments);
                {
                    let __args = Array.prototype.slice.call(arguments);
                    let fibonacciFactor : any = org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibonacciFactor["_$wrappers"][__args[1]].getFactor();
                    super(pivotPointIndicator);
                    if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
                    if(this.fibReversalTyp===undefined) this.fibReversalTyp = null;
                    if(this.fibonacciFactor===undefined) this.fibonacciFactor = null;
                    if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
                    if(this.fibReversalTyp===undefined) this.fibReversalTyp = null;
                    if(this.fibonacciFactor===undefined) this.fibonacciFactor = null;
                    (() => {
                        this.pivotPointIndicator = pivotPointIndicator;
                        this.fibonacciFactor = fibonacciFactor;
                        this.fibReversalTyp = fibReversalTyp;
                    })();
                }
            } else throw new Error('invalid overload');
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let barsOfPreviousPeriod : Array<number> = this.pivotPointIndicator.getBarsOfPreviousPeriod(index);
            if(/* isEmpty */(barsOfPreviousPeriod.length == 0)) return org.ta4j.core.Decimal.NaN_$LI$();
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            for(let index139=0; index139 < barsOfPreviousPeriod.length; index139++) {
                let i = barsOfPreviousPeriod[index139];
                {
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                }
            }
            if(this.fibReversalTyp === FibonacciReversalIndicator.FibReversalTyp.RESISTANCE) {
                return this.pivotPointIndicator.getValue(index).plus(this.fibonacciFactor.multipliedBy(high.minus(low)));
            }
            return this.pivotPointIndicator.getValue(index).minus(this.fibonacciFactor.multipliedBy(high.minus(low)));
        }
    }
    FibonacciReversalIndicator["__class"] = "org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator";
    FibonacciReversalIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];



    export namespace FibonacciReversalIndicator {

        export enum FibReversalTyp {
            SUPPORT, RESISTANCE
        }

        /**
         * Standard Fibonacci factors
         * @enum
         * @property {org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibonacciFactor} Factor1
         * @property {org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibonacciFactor} Factor2
         * @property {org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibonacciFactor} Factor3
         * @class
         */
        export enum FibonacciFactor {
            Factor1, Factor2, Factor3
        }

        /** @ignore */
        export class FibonacciFactor_$WRAPPER {
            factor;

            constructor(protected _$ordinal : number, protected _$name : string, factor) {
                if(this.factor===undefined) this.factor = null;
                this.factor = factor;
            }

            public getFactor() : org.ta4j.core.Decimal {
                return this.factor;
            }
            public name() : string { return this._$name; }
            public ordinal() : number { return this._$ordinal; }
        }
        FibonacciFactor["__class"] = "org.ta4j.core.indicators.pivotpoints.FibonacciReversalIndicator.FibonacciFactor";
        FibonacciFactor["__interfaces"] = ["java.lang.Comparable","java.io.Serializable"];

        FibonacciFactor["_$wrappers"] = [new FibonacciFactor_$WRAPPER(0, "Factor1", org.ta4j.core.Decimal.valueOf(0.382)), new FibonacciFactor_$WRAPPER(1, "Factor2", org.ta4j.core.Decimal.valueOf(0.618)), new FibonacciFactor_$WRAPPER(2, "Factor3", org.ta4j.core.Decimal.ONE_$LI$())];

    }

}

