/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.pivotpoints {
    /**
     * Constructor.
     * <p>
     * Calculates the (standard) reversal for the corresponding pivot level
     * @param {org.ta4j.core.indicators.pivotpoints.PivotPointIndicator} pivotPointIndicator the {@link PivotPointIndicator} for this reversal
     * @param {org.ta4j.core.indicators.pivotpoints.PivotLevel} level the {@link PivotLevel} for this reversal
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class StandardReversalIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ pivotPointIndicator : org.ta4j.core.indicators.pivotpoints.PivotPointIndicator;

        /*private*/ level : org.ta4j.core.indicators.pivotpoints.PivotLevel;

        public constructor(pivotPointIndicator : org.ta4j.core.indicators.pivotpoints.PivotPointIndicator, level : org.ta4j.core.indicators.pivotpoints.PivotLevel) {
            super(pivotPointIndicator);
            if(this.pivotPointIndicator===undefined) this.pivotPointIndicator = null;
            if(this.level===undefined) this.level = null;
            this.pivotPointIndicator = pivotPointIndicator;
            this.level = level;
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let barsOfPreviousPeriod : Array<number> = this.pivotPointIndicator.getBarsOfPreviousPeriod(index);
            if(/* isEmpty */(barsOfPreviousPeriod.length == 0)) {
                return org.ta4j.core.Decimal.NaN_$LI$();
            }
            switch((this.level)) {
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.RESISTANCE_3:
                return this.calculateR3(barsOfPreviousPeriod, index);
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.RESISTANCE_2:
                return this.calculateR2(barsOfPreviousPeriod, index);
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.RESISTANCE_1:
                return this.calculateR1(barsOfPreviousPeriod, index);
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.SUPPORT_1:
                return this.calculateS1(barsOfPreviousPeriod, index);
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.SUPPORT_2:
                return this.calculateS2(barsOfPreviousPeriod, index);
            case org.ta4j.core.indicators.pivotpoints.PivotLevel.SUPPORT_3:
                return this.calculateS3(barsOfPreviousPeriod, index);
            default:
                return org.ta4j.core.Decimal.NaN_$LI$();
            }
        }

        /*private*/ calculateR3(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            for(let index133=0; index133 < barsOfPreviousPeriod.length; index133++) {
                let i = barsOfPreviousPeriod[index133];
                {
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                }
            }
            return high.plus(org.ta4j.core.Decimal.TWO_$LI$().multipliedBy((this.pivotPointIndicator.getValue(index).minus(low))));
        }

        /*private*/ calculateR2(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            for(let index134=0; index134 < barsOfPreviousPeriod.length; index134++) {
                let i = barsOfPreviousPeriod[index134];
                {
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                }
            }
            return this.pivotPointIndicator.getValue(index).plus((high.minus(low)));
        }

        /*private*/ calculateR1(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let low : org.ta4j.core.Decimal = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]).getMinPrice();
            for(let index135=0; index135 < barsOfPreviousPeriod.length; index135++) {
                let i = barsOfPreviousPeriod[index135];
                {
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                }
            }
            return org.ta4j.core.Decimal.TWO_$LI$().multipliedBy(this.pivotPointIndicator.getValue(index)).minus(low);
        }

        /*private*/ calculateS1(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let high : org.ta4j.core.Decimal = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]).getMaxPrice();
            for(let index136=0; index136 < barsOfPreviousPeriod.length; index136++) {
                let i = barsOfPreviousPeriod[index136];
                {
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                }
            }
            return org.ta4j.core.Decimal.TWO_$LI$().multipliedBy(this.pivotPointIndicator.getValue(index)).minus(high);
        }

        /*private*/ calculateS2(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            for(let index137=0; index137 < barsOfPreviousPeriod.length; index137++) {
                let i = barsOfPreviousPeriod[index137];
                {
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                }
            }
            return this.pivotPointIndicator.getValue(index).minus((high.minus(low)));
        }

        /*private*/ calculateS3(barsOfPreviousPeriod : Array<number>, index : number) : org.ta4j.core.Decimal {
            let bar : org.ta4j.core.Bar = this.getTimeSeries().getBar(/* get */barsOfPreviousPeriod[0]);
            let high : org.ta4j.core.Decimal = bar.getMaxPrice();
            let low : org.ta4j.core.Decimal = bar.getMinPrice();
            for(let index138=0; index138 < barsOfPreviousPeriod.length; index138++) {
                let i = barsOfPreviousPeriod[index138];
                {
                    high = (this.getTimeSeries().getBar(i).getMaxPrice()).max(high);
                    low = (this.getTimeSeries().getBar(i).getMinPrice()).min(low);
                }
            }
            return low.minus(org.ta4j.core.Decimal.TWO_$LI$().multipliedBy((high.minus(this.pivotPointIndicator.getValue(index)))));
        }
    }
    StandardReversalIndicator["__class"] = "org.ta4j.core.indicators.pivotpoints.StandardReversalIndicator";
    StandardReversalIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

