/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.volume {
    /**
     * Chaikin Money Flow (CMF) indicator.
     * <p></p>
     * @see <a href="http://stockcharts.com/school/doku.php?id=chart_school:technical_indicators:chaikin_money_flow_cmf">
     * http://stockcharts.com/school/doku.php?id=chart_school:technical_indicators:chaikin_money_flow_cmf"</a>
     * @see <a href="http://www.fmlabs.com/reference/default.htm?url=ChaikinMoneyFlow.htm">
     * http://www.fmlabs.com/reference/default.htm?url=ChaikinMoneyFlow.htm</a>
     * @param {*} series
     * @param {number} timeFrame
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class ChaikinMoneyFlowIndicator extends org.ta4j.core.indicators.CachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ __org_ta4j_core_indicators_volume_ChaikinMoneyFlowIndicator_series : org.ta4j.core.TimeSeries;

        /*private*/ clvIndicator : org.ta4j.core.indicators.helpers.CloseLocationValueIndicator;

        /*private*/ volumeIndicator : org.ta4j.core.indicators.helpers.VolumeIndicator;

        /*private*/ timeFrame : number;

        public constructor(series : org.ta4j.core.TimeSeries, timeFrame : number) {
            super(series);
            if(this.__org_ta4j_core_indicators_volume_ChaikinMoneyFlowIndicator_series===undefined) this.__org_ta4j_core_indicators_volume_ChaikinMoneyFlowIndicator_series = null;
            if(this.clvIndicator===undefined) this.clvIndicator = null;
            if(this.volumeIndicator===undefined) this.volumeIndicator = null;
            if(this.timeFrame===undefined) this.timeFrame = 0;
            this.__org_ta4j_core_indicators_volume_ChaikinMoneyFlowIndicator_series = series;
            this.timeFrame = timeFrame;
            this.clvIndicator = new org.ta4j.core.indicators.helpers.CloseLocationValueIndicator(series);
            this.volumeIndicator = new org.ta4j.core.indicators.helpers.VolumeIndicator(series, timeFrame);
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            let startIndex : number = Math.max(0, index - this.timeFrame + 1);
            let sumOfMoneyFlowVolume : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            for(let i : number = startIndex; i <= index; i++) {
                sumOfMoneyFlowVolume = sumOfMoneyFlowVolume.plus(this.getMoneyFlowVolume(i));
            };
            let sumOfVolume : org.ta4j.core.Decimal = this.volumeIndicator.getValue(index);
            return sumOfMoneyFlowVolume.dividedBy(sumOfVolume);
        }

        /**
         * @param {number} index the bar index
         * @return {org.ta4j.core.Decimal} the money flow volume for the i-th period/bar
         * @private
         */
        /*private*/ getMoneyFlowVolume(index : number) : org.ta4j.core.Decimal {
            return this.clvIndicator.getValue(index).multipliedBy(this.__org_ta4j_core_indicators_volume_ChaikinMoneyFlowIndicator_series.getBar(index).getVolume());
        }

        /**
         * 
         * @return {string}
         */
        public toString() : string {
            return /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor)) + " timeFrame: " + this.timeFrame;
        }
    }
    ChaikinMoneyFlowIndicator["__class"] = "org.ta4j.core.indicators.volume.ChaikinMoneyFlowIndicator";
    ChaikinMoneyFlowIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

