/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.volume {
    /**
     * Intraday Intensity Index
     * see https://www.investopedia.com/terms/i/intradayintensityindex.asp
     * https://www.investopedia.com/terms/i/intradayintensityindex.asp
     * @param {*} series
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class IIIIndicator extends org.ta4j.core.indicators.CachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ closePriceIndicator : org.ta4j.core.indicators.helpers.ClosePriceIndicator;

        /*private*/ maxPriceIndicator : org.ta4j.core.indicators.helpers.MaxPriceIndicator;

        /*private*/ minPriceIndicator : org.ta4j.core.indicators.helpers.MinPriceIndicator;

        /*private*/ volumeIndicator : org.ta4j.core.indicators.helpers.VolumeIndicator;

        public constructor(series : org.ta4j.core.TimeSeries) {
            super(series);
            if(this.closePriceIndicator===undefined) this.closePriceIndicator = null;
            if(this.maxPriceIndicator===undefined) this.maxPriceIndicator = null;
            if(this.minPriceIndicator===undefined) this.minPriceIndicator = null;
            if(this.volumeIndicator===undefined) this.volumeIndicator = null;
            this.closePriceIndicator = new org.ta4j.core.indicators.helpers.ClosePriceIndicator(series);
            this.maxPriceIndicator = new org.ta4j.core.indicators.helpers.MaxPriceIndicator(series);
            this.minPriceIndicator = new org.ta4j.core.indicators.helpers.MinPriceIndicator(series);
            this.volumeIndicator = new org.ta4j.core.indicators.helpers.VolumeIndicator(series);
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            if(index === this.getTimeSeries().getBeginIndex()) {
                return org.ta4j.core.Decimal.ZERO_$LI$();
            }
            let doubleClosePrice : org.ta4j.core.Decimal = org.ta4j.core.Decimal.valueOf$int(2).multipliedBy(this.closePriceIndicator.getValue(index));
            let highmlow : org.ta4j.core.Decimal = this.maxPriceIndicator.getValue(index).minus(this.minPriceIndicator.getValue(index));
            let highplow : org.ta4j.core.Decimal = this.maxPriceIndicator.getValue(index).plus(this.minPriceIndicator.getValue(index));
            return (doubleClosePrice.minus(highplow)).dividedBy(highmlow.multipliedBy(this.volumeIndicator.getValue(index)));
        }
    }
    IIIIndicator["__class"] = "org.ta4j.core.indicators.volume.IIIIndicator";
    IIIIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

