/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.volume {
    /**
     * Negative Volume Index (NVI) indicator.
     * <p></p>
     * @see <a href="http://stockcharts.com/school/doku.php?id=chart_school:technical_indicators:negative_volume_inde">
     * http://stockcharts.com/school/doku.php?id=chart_school:technical_indicators:negative_volume_inde</a>
     * @see <a href="http://www.metastock.com/Customer/Resources/TAAZ/Default.aspx?p=75">
     * http://www.metastock.com/Customer/Resources/TAAZ/Default.aspx?p=75</a>
     * @see <a href="http://www.investopedia.com/terms/n/nvi.asp">
     * http://www.investopedia.com/terms/n/nvi.asp</a>
     * @param {*} series
     * @class
     * @extends org.ta4j.core.indicators.RecursiveCachedIndicator
     */
    export class NVIIndicator extends org.ta4j.core.indicators.RecursiveCachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ __org_ta4j_core_indicators_volume_NVIIndicator_series : org.ta4j.core.TimeSeries;

        public constructor(series : org.ta4j.core.TimeSeries) {
            super(series);
            if(this.__org_ta4j_core_indicators_volume_NVIIndicator_series===undefined) this.__org_ta4j_core_indicators_volume_NVIIndicator_series = null;
            this.__org_ta4j_core_indicators_volume_NVIIndicator_series = series;
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            if(index === 0) {
                return org.ta4j.core.Decimal.THOUSAND_$LI$();
            }
            let currentBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_volume_NVIIndicator_series.getBar(index);
            let previousBar : org.ta4j.core.Bar = this.__org_ta4j_core_indicators_volume_NVIIndicator_series.getBar(index - 1);
            let previousValue : org.ta4j.core.Decimal = this.getValue(index - 1);
            if(currentBar.getVolume().isLessThan(previousBar.getVolume())) {
                let currentPrice : org.ta4j.core.Decimal = currentBar.getClosePrice();
                let previousPrice : org.ta4j.core.Decimal = previousBar.getClosePrice();
                let priceChangeRatio : org.ta4j.core.Decimal = currentPrice.minus(previousPrice).dividedBy(previousPrice);
                return previousValue.plus(priceChangeRatio.multipliedBy(previousValue));
            }
            return previousValue;
        }
    }
    NVIIndicator["__class"] = "org.ta4j.core.indicators.volume.NVIIndicator";
    NVIIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

