/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.indicators.volume {
    /**
     * Constructor.
     * @param {*} series the series
     * @param {number} timeFrame the time frame
     * @class
     * @extends org.ta4j.core.indicators.CachedIndicator
     */
    export class VWAPIndicator extends org.ta4j.core.indicators.CachedIndicator<org.ta4j.core.Decimal> {
        /*private*/ timeFrame : number;

        /*private*/ typicalPrice : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        /*private*/ volume : org.ta4j.core.Indicator<org.ta4j.core.Decimal>;

        public constructor(series : org.ta4j.core.TimeSeries, timeFrame : number) {
            super(series);
            if(this.timeFrame===undefined) this.timeFrame = 0;
            if(this.typicalPrice===undefined) this.typicalPrice = null;
            if(this.volume===undefined) this.volume = null;
            this.timeFrame = timeFrame;
            this.typicalPrice = new org.ta4j.core.indicators.helpers.TypicalPriceIndicator(series);
            this.volume = new org.ta4j.core.indicators.helpers.VolumeIndicator(series);
        }

        /**
         * 
         * @param {number} index
         * @return {org.ta4j.core.Decimal}
         */
        calculate(index : number) : org.ta4j.core.Decimal {
            if(index <= 0) {
                return this.typicalPrice.getValue(index);
            }
            let startIndex : number = Math.max(0, index - this.timeFrame + 1);
            let cumulativeTPV : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            let cumulativeVolume : org.ta4j.core.Decimal = org.ta4j.core.Decimal.ZERO_$LI$();
            for(let i : number = startIndex; i <= index; i++) {
                let currentVolume : org.ta4j.core.Decimal = this.volume.getValue(i);
                cumulativeTPV = cumulativeTPV.plus(this.typicalPrice.getValue(i).multipliedBy(currentVolume));
                cumulativeVolume = cumulativeVolume.plus(currentVolume);
            };
            return cumulativeTPV.dividedBy(cumulativeVolume);
        }

        /**
         * 
         * @return {string}
         */
        public toString() : string {
            return /* getSimpleName */(c => c["__class"]?c["__class"].substring(c["__class"].lastIndexOf('.')+1):c["name"].substring(c["name"].lastIndexOf('.')+1))((<any>this.constructor)) + " timeFrame: " + this.timeFrame;
        }
    }
    VWAPIndicator["__class"] = "org.ta4j.core.indicators.volume.VWAPIndicator";
    VWAPIndicator["__interfaces"] = ["org.ta4j.core.Indicator","java.io.Serializable"];


}

