/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.trading.rules {
    /**
     * Constructor.
     * @param {org.ta4j.core.indicators.helpers.ClosePriceIndicator} closePrice the close price indicator
     * @param {org.ta4j.core.Decimal} gainPercentage the gain percentage
     * @class
     * @extends org.ta4j.core.trading.rules.AbstractRule
     */
    export class StopGainRule extends org.ta4j.core.trading.rules.AbstractRule {
        /**
         * The close price indicator
         */
        /*private*/ closePrice : org.ta4j.core.indicators.helpers.ClosePriceIndicator;

        /**
         * The gain ratio threshold (e.g. 1.03 for 3%)
         */
        /*private*/ gainRatioThreshold : org.ta4j.core.Decimal;

        public constructor(closePrice : org.ta4j.core.indicators.helpers.ClosePriceIndicator, gainPercentage : org.ta4j.core.Decimal) {
            super();
            if(this.closePrice===undefined) this.closePrice = null;
            if(this.gainRatioThreshold===undefined) this.gainRatioThreshold = null;
            this.closePrice = closePrice;
            this.gainRatioThreshold = org.ta4j.core.Decimal.HUNDRED_$LI$().plus(gainPercentage).dividedBy(org.ta4j.core.Decimal.HUNDRED_$LI$());
        }

        public isSatisfied$int$org_ta4j_core_TradingRecord(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean {
            let satisfied : boolean = false;
            if(tradingRecord != null) {
                let currentTrade : org.ta4j.core.Trade = tradingRecord.getCurrentTrade();
                if(currentTrade.isOpened()) {
                    let entryPrice : org.ta4j.core.Decimal = currentTrade.getEntry().getPrice();
                    let currentPrice : org.ta4j.core.Decimal = this.closePrice.getValue(index);
                    let threshold : org.ta4j.core.Decimal = entryPrice.multipliedBy(this.gainRatioThreshold);
                    if(currentTrade.getEntry().isBuy()) {
                        satisfied = currentPrice.isGreaterThanOrEqual(threshold);
                    } else {
                        satisfied = currentPrice.isLessThanOrEqual(threshold);
                    }
                }
            }
            this.traceIsSatisfied(index, satisfied);
            return satisfied;
        }

        /**
         * 
         * @param {number} index
         * @param {*} tradingRecord
         * @return {boolean}
         */
        public isSatisfied(index? : any, tradingRecord? : any) : any {
            if(((typeof index === 'number') || index === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.isSatisfied$int$org_ta4j_core_TradingRecord(index, tradingRecord);
            } else if(((typeof index === 'number') || index === null) && tradingRecord === undefined) {
                return <any>this.isSatisfied$int(index);
            } else throw new Error('invalid overload');
        }
    }
    StopGainRule["__class"] = "org.ta4j.core.trading.rules.StopGainRule";
    StopGainRule["__interfaces"] = ["org.ta4j.core.Rule"];


}

