/* Generated from Java with JSweet 2.2.0-SNAPSHOT - http://www.jsweet.org */
namespace org.ta4j.core.trading.rules {
    /**
     * Constructor.
     * @param {org.ta4j.core.Order.OrderType} orderType the type of the order since we have to wait for
     * @param {number} numberOfBars the number of bars to wait for
     * @class
     * @extends org.ta4j.core.trading.rules.AbstractRule
     */
    export class WaitForRule extends org.ta4j.core.trading.rules.AbstractRule {
        /**
         * The type of the order since we have to wait for
         */
        /*private*/ orderType : Order.OrderType;

        /**
         * The number of bars to wait for
         */
        /*private*/ numberOfBars : number;

        public constructor(orderType : Order.OrderType, numberOfBars : number) {
            super();
            if(this.orderType===undefined) this.orderType = null;
            if(this.numberOfBars===undefined) this.numberOfBars = 0;
            this.orderType = orderType;
            this.numberOfBars = numberOfBars;
        }

        public isSatisfied$int$org_ta4j_core_TradingRecord(index : number, tradingRecord : org.ta4j.core.TradingRecord) : boolean {
            let satisfied : boolean = false;
            if(tradingRecord != null) {
                let lastOrder : org.ta4j.core.Order = tradingRecord['getLastOrder$org_ta4j_core_Order_OrderType'](this.orderType);
                if(lastOrder != null) {
                    let currentNumberOfBars : number = index - lastOrder.getIndex();
                    satisfied = currentNumberOfBars >= this.numberOfBars;
                }
            }
            this.traceIsSatisfied(index, satisfied);
            return satisfied;
        }

        /**
         * 
         * @param {number} index
         * @param {*} tradingRecord
         * @return {boolean}
         */
        public isSatisfied(index? : any, tradingRecord? : any) : any {
            if(((typeof index === 'number') || index === null) && ((tradingRecord != null && (tradingRecord["__interfaces"] != null && tradingRecord["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0 || tradingRecord.constructor != null && tradingRecord.constructor["__interfaces"] != null && tradingRecord.constructor["__interfaces"].indexOf("org.ta4j.core.TradingRecord") >= 0)) || tradingRecord === null)) {
                return <any>this.isSatisfied$int$org_ta4j_core_TradingRecord(index, tradingRecord);
            } else if(((typeof index === 'number') || index === null) && tradingRecord === undefined) {
                return <any>this.isSatisfied$int(index);
            } else throw new Error('invalid overload');
        }
    }
    WaitForRule["__class"] = "org.ta4j.core.trading.rules.WaitForRule";
    WaitForRule["__interfaces"] = ["org.ta4j.core.Rule"];


}

